/*
 * $Log: about.c,v $
 * Revision 1.6  1998/01/18 18:54:20  jrh
 * for 1.63 release
 *
 * Revision 1.5  1997/08/23 21:13:39  jrh
 * pre config removal
 *
 * Revision 1.4  1996/07/09 12:25:57  jrh
 * post fsel (1.60)
 *
 * Revision 1.3  1996/07/09  09:15:15  jrh
 * Correct sH handling
 *
 * Revision 1.2  1995/11/12  15:29:37  root
 * Added OS info
 *
 * Revision 1.1  1995/09/16  17:22:18  root
 * Initial login under Linux
 *
 * Revision 1.5  1995/05/31  17:05:26  jrh
 * No CR option and new XPR (nothing)
 *
 * Revision 1.4  1995/02/07  16:52:32  jrh
 * Add 95 to copyright
 *
 * Revision 1.3  1994/06/09  16:22:27  jrh
 * Add generic text messages
 *
 * Revision 1.2  1994/05/31  22:19:55  jrh
 * c68 v41.3c fixes
 *
 * Revision 1.1  1994/05/30  21:43:32  jrh
 * Initial checkin at v1.33
 *
 */

static char rcsid[] ="$Id: about.c,v 1.6 1998/01/18 18:54:20 jrh Exp jrh $";

#include <stdio.h>
#include <qdos.h>
#include <qptr.h>
#include <stdarg.h>

#include "defs.h"

extern short hermvers(void);

extern int QPTR_VERS;
extern struct WM_wwork *Main_ww;

Prototype struct WM_wwork *AboutQTPI (struct WM_wwork *, int, char **msg);

static long ACHOICE (struct WM_wwork *, struct WM_litm *, struct WM_wstat *);
static struct WM_action achoice = {JSR, wm_actli, ACHOICE};


struct WM_wwork *AboutQTPI (struct WM_wwork *pwk, int flag, char **msg)
{
    static QD_TEXTI (AOK, "OK");

    static struct WM_wstat ws = {0};
    static struct WM_litm litm[1 + 1] =
    {
	{20, 14, 170, 144, 0, 0, TYP_TEXT, 3, &AOK, 0, &achoice},
	{-1}
    };

    static struct WM_infw infw[1 + 1] =	/* information window */
    {

	{360, 160, 2, 1, 0, 0, 0, 0, NULL},
	{-1}			/* end of array */
    };

    static struct WM_wwork ww =	/* window working definition */
    {
	NULL,			/* *wstat; pointer to status area */
	NULL,			/* *wscale this was pointer to WDEF */
	0,			/* chid    channel ID */
	NULL,			/* *pprec  pointer to pointer record */
	0,			/* psave   pointer position saved */
	0, 0, 0, 0,		/* 4 zero */
	NULL,			/* *splst  pointer to sprite list */
	364, 162,		/* xsize, ysize */
	0, 0,			/* xorg, yorg           and origin */
	2,			/* flag                 no clear + shadow */
	1, 7, 0,		/* borw, borc, papr border width/clr, paper */
	NULL,			/* *sprite pointer to sprite */
	1, CL_MHIGH,		/* curw, curc current item width/clr */
	CL_MPUNAV, CL_MIUNAV, NULL, NULL, /* uback, uink, *ublob, *upatt unav*/
	7, 0, NULL, NULL,	/* aback, aink, *ablob, *apatt avail */
	CL_MPSLCT, CL_MISLCT, NULL, NULL,  /* sback, sink, *sblob, *spatt sel */
	NULL,			/* *help */
	1, 0, infw,		/* ninfo, ninob, *pinfo info winds */
	1, litm,		/* nlitm, *plitm        loose items */
	0, NULL			/* nappl  *pappl        appl winds */
    };
    static char *pText[] =
    {
	"Quintessential",
	"TeleComms",
	"Pointer",
	"Interface",
	"",
	"",
	"(c) Jonathan Hudson 1993-1998",
	"jrhudson@bigfoot.com",
	NULL
    };

    char **p;
    int i;
    short n;

    ws.wwork = &ww;		/* cross references */
    ww.wstat = &ws;
    ws.wmode = FORM_QL4;

    ws.citem = -1;		/* no current item  */
    ws.ciact = NULL;		/* or current item routine */
    ws.litem[0] = WSI_MKAV;	/* preset ESC return */
    ww.xorg = ww.yorg = 0;

    if (flag)
    {
	ww.nlitm = 1;
	ww.plitm = litm;
    }
    else
    {
	ww.nlitm = 0;
	ww.plitm = NULL;
    }

    wm_pulld (&ww, Main_ww->xorg + (Main_ww->xsize-364)/2, 
	      Main_ww->yorg + (Main_ww->ysize-162)/2);
    wm_wdraw (&ww);

    wm_swinf (&ww, 0, -1);
    sd_setst (ww.chid, -1, 0);
    sd_setpa (ww.chid, -1, 0);
    sd_setin (ww.chid, -1, 2);

    sd_setsz (ww.chid, -1, 3, 1); 
    sd_setmd (ww.chid, -1, 1);

    n = (ww.xsize - 80)/2;
    for (i = 0; i < 10; i++)
    {
	sd_pixp (ww.chid, -1, n + i, 3 + i);
	if (i == 7)
	{
	    sd_setin (ww.chid, -1, 7);
	}
	io_sstrg (ww.chid, -1, "QTPI", 4);
    }

    sd_setmd (ww.chid, -1, 0);
    sd_setsz (ww.chid, -1, 0, 0);
    sd_setin (ww.chid, -1, 7);

    if(msg)
    {
	for (i = 0, p = msg; *p; p++, i++)	
	{
	    n = strlen (*p);
	    sd_pos (ww.chid, -1, (ww.xsize/6 - n)/2, 4 + i);
	    io_sstrg (ww.chid, -1, *p, n);
	}
    }
    else
    {
	for (i = 0, p = pText; *p; p++, i++)
	{
	    char buf[80];
	    if (i == 4)
	    {
		sprintf(buf, "v%s for %s", QTPI_VERS, osnam);
		*p = buf;
	    }
	    n = strlen (*p);
	    sd_pos (ww.chid, -1, (ww.xsize/6 - n)/2, 4 + i);
	    io_sstrg (ww.chid, -1, *p, n);
	}

	if(useFS)
	{
	    sd_pos (ww.chid, -1, (ww.xsize/6 - 6), 5 + i);
	    io_sstrg (ww.chid, -1, "FSEL", (short) 4);
	}
    
	{
	    char txt[16];
	    short hv;
	    
	    sprintf (txt, "PE %-4.4s", &QPTR_VERS);
	    sd_pos (ww.chid, -1, 1, 5 + i);
	    io_sstrg (ww.chid, -1, txt, (short) 7);
	    hv = hermvers();
	    sHermes = ((hv >> 8) == 3);
	
	    if(hv)
	    {
		sprintf(txt,"IPC %d.%02d", (hv >> 8), hv & 0xff);
	    }
	    else
	    {
		strcpy(txt, "non-*hermes");
	    }
	    n = strlen(txt);
	    sd_pos (ww.chid, -1, (ww.xsize/6 - n)/2, 5 + i);
	    io_sstrg (ww.chid, -1, txt, strlen(txt));

	}
    }

    if (flag)
    {
        wm_ldraw (&ww, -1);
	while (!wm_rptr (&ww))
	{
	    if (ws.evnt & PT_CAN)
		break;
	}

	wm_cluns (&ww);		/* throw it away */
	return NULL;
    }
    else
    {
	return &ww;
    }
}

static long ACHOICE (struct WM_wwork *wwk, struct WM_litm *li, struct WM_wstat *wst)
{
    return PT__CAN;		/* and return CAN event */
}


