#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <stdarg.h>
# include <qdos.h>

#if !defined(DEMO) && !defined(TEST)
# include "qstr.h"
#else
 char ScriptLog[40] = "ram1_demo_log";
#endif

/*
 * First code is 0x6008 + even text length
 * This code is at 10 + even text length
 */

static unsigned short jcode[] = {
                        0x2CBC, 0x0000, 0x0018, /*  move.l  #$18,(a6) */
                        0xDDFC, 0x0000, 0x0018, /*  add.l   #$18,a6   */
                        0x9BFC, 0x0000, 0x0018, /*  sub.l   #$18,a5   */
                        0x3478, 0x0154,         /*  move.w  $154,a2   */
                        0x4EEA, 0x4000};        /*  jmp     $4000(a2) */

extern int io_open3(char *, int, int);
extern void vStartMBJob (char *, char *, char *, int, int,...);
extern void StartMBJob (char *, char *, char *, int, int, int *);

int OpenAppend(char *nam, int jobid)
{
    int chid;
    if((chid = io_open3(nam, 2, jobid)) < 0)
    {
        chid = io_open3(nam, 0, jobid);
        fs_pos(chid, 0x7fffff, 0);  /* Old ST-Ql had 24 bit file pointers ! */
                                    /* so no 9Mb log files !!! */
    }
    return chid;
}

char * GetScriptLog (void)
{
    static char mlog[40];
    static short nlog = 0;
    sprintf(mlog, ScriptLog, nlog++);
    return mlog;
}

void StartMBJob (char *name, char *inp, char *cmd, int timo, int nchan, int *chn)
{
    int jobid;
    void *jobaddr;
    struct JOBHEADER *jh;                   /* ha ha */
    short elen, nlen;
    long codsiz;
       
    nlen = strlen(name);
    elen = (nlen + 1) & ~1;
    codsiz = 10 + elen + sizeof(jcode);
    jobid = mt_cjob(codsiz, 0xd00, NULL, 0, &jobaddr);
    
    if(jobid > 0)
    {
        void *stk;
        int mchn[2];
        /* Set up our little code segment */
        
        *((short *)jobaddr) = 0x6008 + elen;
        *((short *)jobaddr + 1) = 0;
        *((short *)jobaddr + 2) = 0;
        *((short *)jobaddr + 3) = 0x4afb;
        *((short *)jobaddr + 4) = nlen;
        memcpy(((short *)jobaddr + 5), name, nlen);
        memcpy(((char *) jobaddr + 10 + elen), jcode, sizeof(jcode));
        jh = (((struct JOBHEADER *)jobaddr) - 1);
        
        if(inp)
        {
            int inchan;
            inchan = io_open3(inp, 1, jobid);
            if(inchan > 0)
            {
                jh->jb_regs.jb_A0 = (addreg_t) inchan;
            }
        }

        stk = (void *) jh->jb_regs.jb_A7;

        if(cmd && (nlen = strlen(cmd)))
        {
            elen = (nlen+1) & ~1;
	}
        else
        {
            nlen = elen = 0;
	} 

	if(nchan == -1)         /* Kludge for QTPI scripts */
	{
	    char *mlog;
	    extern int OpenAppend(char *, int);
	    
            mchn[0] = io_open3("pipet",0,jobid);
            /*
             * read from pipet returns EOF, so MB exits after prog is run
             * Of course we have a pipet, cos we're a recent Minerva :-)
             * but I guess an error code here will have the same effect
             * and I could have just put -1 !!!!
             */
            mlog = GetScriptLog();
            mchn[1] = OpenAppend(mlog, jobid);
            nchan = 2;
            chn = mchn;
	}
        elen = elen + (nchan << 2);
        
        if(elen)
        {
            ((char *)stk) -= elen;
            (void *) jh->jb_regs.jb_A7 = stk;
	}
        if(*((short *)stk)++ = nchan)
        {
            while(nchan--)
            {
                *((long *)stk)++ = *chn++;
            }
	}
        *((short *)stk)++ = nlen;
        while (nlen--)
        {
            *((char *)stk)++ = *cmd++;
        }
        mt_activ(jobid, 8, 0);
    }
}
void vStartMBJob (char *name, char *inp, char *cmd, int timo, int n,...)
{
    int *l;
    l =  &n;
    StartMBJob (name, inp, cmd, timo, n, (int *) l+1);    
}


#ifdef TEST
/*
 * Suppose I better explain some of this hackery ....
 *
 * 
 * StartMBJob (jobName, input_prog, cmd$, sync flag, no_chans, array_of_ChanIDs);
 *
 * and the varargs version  
 * vStartMBJob (jobName, input_prog, cmd$, sync flag, no_chans, ...);
 *                      
 *                          the ... bit is channel IDS
 * e.g.
 * vStartMBJob (jobName, input_prog, cmd$, sync flag, no_chans, chan1, chan2);
 *
 * Suppose it might have been nice to return the Job ID.
 *
 * This is 'researched' from QView docs and examples.
 */
 
int main (int ac, char **av)
{
    char *sp;
    short nc;

    sp = *(av + 1);
    nc = *((short *) (sp));
    sp += 2;
    
    if(nc)
    {
     StartMBJob ("MBasic", "ram2_demo_bas", "Hello World", 0, nc, (int *) sp);
    }
    else
    {
     vStartMBJob ("MBasic", "ram2_demo_bas", "Hello World", 0, 0, 0x00020002);
    }
}

int (*_Cstart) (int, char **) = main;

#endif

