/*
 * $Log: pqdial.c,v $
 * Revision 1.3  1996/12/23 22:32:48  jrh
 * Checkin for 1.62
 *
 * Revision 1.2  1995/11/12  15:29:37  root
 * No mesage !
 *
 * Revision 1.1  1995/09/16  17:22:18  root
 * Initial login under Linux
 *
 * Revision 1.8  1995/04/01  00:02:26  jrh
 * Fix resized menu redraw bug
 *
 * Revision 1.7  1995/03/24  16:29:08  jrh
 * streamline menu code
 *
 * Revision 1.6  1995/03/18  12:15:37  jrh
 * C68 v4.5
 *
 * Revision 1.5  1995/03/12  23:00:08  jrh
 * scripting
 *
 * Revision 1.4  1995/02/12  18:03:25  jrh
 * beta for scripting
 *
 * Revision 1.3  1994/12/15  21:31:12  jrh
 * menu changes
 *
 * Revision 1.2  1994/05/31  22:19:55  jrh
 * c68 v41.3c fixes
 *
 * Revision 1.1  1994/05/30  21:43:24  jrh
 * Initial checkin at v1.33
 *
 */

static char rcsid[] ="$Id: pqdial.c,v 1.3 1996/12/23 22:32:48 jrh Exp $";

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <qdos.h>
#include <qptr.h>
#include <unistd.h>
#include <ctype.h>

#include "defs.h"

#define RETITM 39

Local int CompareItem (PPHONE_LIST, PPHONE_LIST);
Prototype int CompareMenu (PMDEF, PMDEF);
Prototype BuildList (struct WM_wwork *);
Local MakeSList ();
Prototype SaveList (int);
Prototype FreeList (PLLIST *);
Local EditDPage (struct WM_wwork *, int);
Local DialModem (int);
Local ListDial (struct WM_wwork *);
Local DrawLine (int);
Prototype MenuDial (struct WM_wwork *);

typedef struct mitem
{
    short len;
    char chrs[62];
}
MITEM, *PMITEM;

static long DMLIST (struct WM_wwork *, struct WM_menw *, char *, short, short);
static long MCOMMAND (struct WM_wwork *, struct WM_menw *, char *, short, short);

static long MESC (struct WM_wwork *, struct WM_litm *);
static long LCOMMAND  (struct WM_wwork *, struct WM_litm *);

static long DMDIAL  (struct WM_wwork *, struct WM_menw *, char *, short, short);
static long DMEDIT  (struct WM_wwork *, struct WM_menw *, char *, short, short);
static long DMZAP  (struct WM_wwork *, struct WM_menw *, char *, short, short);
static long DMADD  (struct WM_wwork *, struct WM_menw *, char *, short, short);
static long DMOPEN  (struct WM_wwork *, struct WM_menw *, char *, short, short);
static long DMSAVE  (struct WM_wwork *, struct WM_menw *, char *, short, short);
static long DMSAVEAS  (struct WM_wwork *, struct WM_menw *, char *, short, short);

static struct WM_action dmdial = {JSR, wm_actme, DMDIAL};
static struct WM_action dmedit = {JSR, wm_actme, DMEDIT};
static struct WM_action dmzap = {JSR, wm_actme, DMZAP};
static struct WM_action dmadd = {JSR, wm_actme, DMADD};
static struct WM_action dmopen = {JSR, wm_actme, DMOPEN};
static struct WM_action dmsave = {JSR, wm_actme, DMSAVE};
static struct WM_action dmsaveas = {JSR, wm_actme, DMSAVEAS};
static struct WM_action dmlist = {JSR, wm_actme, DMLIST};

static struct WM_action mcommand = {JSR, wm_actme, MCOMMAND};
static struct WM_action lcommand = {JSR, wm_actli, LCOMMAND};
static struct WM_action mesc = {JSR, wm_actli, MESC};

static PLLIST pList = NULL; 
static PLLIST pScreen = NULL;

static QD_TEXTI (ESCAPE, "Quit");

#define DM_DIAL     0
#define DM_EDIT     1
#define DM_ZAP      2
#define DM_ADD      3
#define DM_OPEN     4
#define DM_SAVE     5
#define DM_SAVEAS   6
#define DM_LIST     7

#define DMITEMS     8

static QD_TEXTI (dm0, "Dial");
static QD_TEXTI (dm1, "Edit ...");
static QD_TEXTI (dm2, "Zap");
static QD_TEXTI (dm3, "New Entry ...");
static QD_TEXTI (dm4, "Open ...");
static QD_TEXTI (dm5, "Save  ...");
static QD_TEXTI (dm6, "Save As ...");
static QD_TEXTI (dm7, "List ...");

static MDEF Dm[] =
{
    {(struct QD_text *) &dm0, -1, 0, PT_CAN, &dmdial},
    {(struct QD_text *) &dm1, -1, 0, 0, &dmedit},
    {(struct QD_text *) &dm2, -1, 0, 0, &dmzap},
    {(struct QD_text *) &dm3, -1, 0, 0, &dmadd},
    {(struct QD_text *) &dm4, -1, 0, 0, &dmopen},
    {(struct QD_text *) &dm5, -1, 0, 0, &dmsave},
    {(struct QD_text *) &dm6, -2, 0, 0, &dmsaveas},
    {(struct QD_text *) &dm7, -1, 0, 0, &dmlist},
};

extern LLIST _DmMenu_[];
LLIST _DmMenu_[] =
{
    {&_DmMenu_[1], &Dm[0]},
    {&_DmMenu_[2], &Dm[1]},
    {&_DmMenu_[3], &Dm[2]},
    {&_DmMenu_[4], &Dm[3]},
    {&_DmMenu_[5], &Dm[4]},
    {&_DmMenu_[6], &Dm[5]},
    {&_DmMenu_[7], &Dm[6]},
    {NULL,         &Dm[7]}
};

static int pb_entry;
static struct WM_litm dlitem[2] =
{
    {24, 10,			/* xsize, ysize         size */
     120, 2,			/* xorg, yorg           and origin */
     0, 0,			/* xjst, yjst           justification */
     TYP_TEXT, 3,		/* type, skey           type and select key */
     &ESCAPE,			/* *pobj                pointer to object */
     1,				/* item                 item number */
     &mesc},			/* *pact                pointer to action */
    {-1}
};

static QD_TEXTI (COMMAND, "Commands F3");

static struct WM_litm plitem[3] =
{
    {72, 10,			/* xsize, ysize         size */
     160, 2,			/* xorg, yorg           and origin */
     0, 0,			/* xjst, yjst           justification */
     TYP_TEXT, 0xf0,		/* type, skey           type and select key */
     &COMMAND,			/* *pobj                pointer to object */
     0,				/* item                 item number */
     &lcommand},		/* *pact                pointer to action */
    {24, 10,			/* xsize, ysize         size */
     300, 2,			/* xorg, yorg           and origin */
     0, 0,			/* xjst, yjst           justification */
     TYP_TEXT, 3,		/* type, skey           type and select key */
     &ESCAPE,			/* *pobj                pointer to object */
     1,				/* item                 item number */
     &mesc},			/* *pact                pointer to action */
    {-1}
};

/*
 * This is where the non QCON stuff is in p->flags
 */

static char Answer[80];

static char *pCheck = "QeM v4";

#define VCHECKL      6

static void Reduce(char *p, char *q)
{
    for(; *p; p++)
    {
        if(isdigit(*p))
        {
            *q++ = *p;
        }
    }
    *q = 0;
}
int SearchBook(char *txt)
{
    PPHONE_LIST pItem;
    PLLIST pz;
    char ntxt[64];
    char xtxt[64];
    short indx = 0;
    
    Reduce(txt, ntxt);
    
    for (pz = pList; pz; pz = pz->next)
    {
        pItem = (PPHONE_LIST) pz->item;
        if(stricmp(pItem->Name, txt) == 0)
        {
            break;
        }
        if(*ntxt)
        {
            Reduce(pItem->Phone, xtxt);
            if(strcmp (ntxt, xtxt) == 0)
            {
                break;
            }
	}
        indx++;
    }
    if(pz)
    {
        DialModem(indx);
    }
    return (int)pz;
}

static int CompareItem (pItem, pNew)
PPHONE_LIST pItem, pNew;
{
    return (strcmp (pItem->Name, pNew->Name) < 0);
}
int CompareMenu (PMDEF s, PMDEF t)
{
    return (strcmp (((PMITEM) s->qtext)->chrs, ((PMITEM) t->qtext)->chrs) < 0);
}

BuildList (struct WM_wwork * wwk)
{
    PHONE_LIST Item;
    PLLIST pp;

    int sts;
    int fd;
    char vCheck[VCHECKL];
    char *p;

    
    if (*Qbook_dat && (fd = io_open (Qbook_dat, IO_OLD)) > 0)
    {
	io_fstrg (fd, -1, (char *) vCheck, (short) VCHECKL);
	if (strncmp (vCheck, pCheck, (size_t) VCHECKL) != 0)
	{
	    io_close (fd);
	    if (wwk)
	    {
		int n;

		n = menu_choice (wwk, "Wrong version of phone book", 2, 1, "OK", "Quit");
		if (n == 0)
		{
		    return 0;
		}
		else
		{
		    return -1;
		}
	    }
	    else
	    {
		OutError ("Wrong version of Phone Book");
		return 0;
	    }
	}

	if (pList)
	{
	    FreeList (&pList);
	}
	if (pScreen)
	{
	    FreeXList (&pScreen);
	}

	if (fd > 0)
	{
	    while (io_fstrg (fd, -1, (char *) &Item, (short) PHONE_RECORD) == PHONE_RECORD)
	    {
		pp = (PLLIST) xmalloc (sizeof (LLIST));
		(PPHONE_LIST) pp->item = (PPHONE_LIST) xmalloc (PHONE_RECORD);
		memcpy (pp->item, &Item, PHONE_RECORD);
                ((PHONE_LIST *) pp->item)->Flags[13] ^= 1;
		ins_list (&pList, pp, CompareItem);
	    }
	}
	io_close (fd);
        return 1;
    }
    return 0;
}
static MakeSList ()
{
    int n;
    PLLIST p;

    for (n = 0, p = pList; p; p = p->next, n++)
    {
	PMITEM s;
	PMDEF pm;
	PLLIST pl;
	PPHONE_LIST pp;
	char c;

	pp = (PPHONE_LIST) p->item;

	s = (PMITEM) xmalloc (sizeof (MITEM));

	if (n < 10)
	{
	    c = n + 48;
	}
	else if (n > 9 && n < 36)
	{
	    c = n + 55;
	}
	else
	{
	    c = ' ';
	}
	/*
	 * Build list with initals first
	 */
	sprintf (s->chrs, "%c %-31s %-23.23s", c, pp->Name, pp->Phone);
	s->len = strlen (s->chrs);
	pm = (PMDEF) xmalloc (sizeof (MDEF));
	pm->qtext = (struct QD_text *) s;
	pm->status = WSI_AVBL;
	pm->retval = 0;
	pm->action = &mcommand;
	pm->skey = (c == ' ') ? 0 : -1;
	pl = (PLLIST) xmalloc (sizeof (LLIST));
	pl->item = pm;
	pl->next = NULL;
	ins_list (&pScreen, pl, NULL);
    }
    return n;
}

SaveList (int flag)
{
    int fd;
    PLLIST pNode;
    char *p;

    if (flag || bSave)
    {
	if ((fd = io_open (Qbook_dat, IO_NEW)) > 0)
	{
	    fs_save (fd, (char *) pCheck, VCHECKL);
	    for (pNode = pList; pNode; pNode = pNode->next)
	    {
                ((PHONE_LIST *) pNode->item)->Flags[13] ^= 1;
		fs_save (fd, pNode->item, (int) PHONE_RECORD);
	    }
            io_trunc(fd, -1);
	    io_close (fd);
	}
    }
}

FreeList (PLLIST * pHead)
{
    PLLIST pNode, pDead;

    for (pNode = *pHead; pNode;)
    {
	pDead = pNode;
	pNode = pNode->next;
	if (pDead->item)
	{
	    xfree (pDead->item);
	}
	xfree (pDead);
    }
    *pHead = NULL;
}

static EditDPage (struct WM_wwork *wwk, int item)
{
    PPHONE_LIST pItem;
    int i;
    PLLIST pz, pl;
    int retn = 0;

    pl = NULL;

    if (item == -1)
    {
	pz = (PLLIST) xmalloc (sizeof (LLIST));
	pItem = (PPHONE_LIST) xmalloc (sizeof (PHONE_LIST));
	pz->item = pItem;
        SLoad_Setup ();
    }
    else
    {
	for (pz = pList, i = 0; i < item; i++)
	{
	    pl = pz;
	    pz = pz->next;
	}
	pItem = pz->item;

        SLoad_Flags (pItem);
    }

    SetText (DialOpts, pItem);
    if ((retn = EditDial (wwk, DialOpts)))
    {
        UnloadSer (pItem);
    }

    if (retn == 0)
    {
	if (item == -1)
	{
	    xfree (pItem);
	    xfree (pz);
	}
    }
    else
    {
	if (item != -1)
	{
	    if (pl)
	    {
		pl->next = pz->next;
	    }
	    else
	    {
		pList = pz->next;
	    }
	}
	ins_list (&pList, pz, CompareItem);
    }
    return retn;
}
static DialModem (int nitem)
{
    PPHONE_LIST pItem;
    int i;
    PLLIST pz;

    for (pz = pList, i = 0; i < nitem; i++)
    {
	pz = pz->next;
    }
    pItem = (PPHONE_LIST) pz->item;

    strcpy (pPhoneNo, pItem->Phone);
    ConfigSer (pItem);

    if (*pItem->Protocol && stricmp (MyProtocol, pItem->Protocol) != 0)
    {
	if (FindXPRExe(pItem->Protocol))
	{
	    strcpy (MyProtocol, pItem->Protocol);
	    XPRStatus = XPRUse (MyProtocol);
  	    strcpy (xproto, MyProtocol);
	}
    }
    ReDial (*pItem->Modem ? pItem->Modem : NULL);
    DoStatus ();
    pAnswer = (char *) strcat ((char *) strcpy (Answer, pItem->Logon), 
			       pItem->Logon2);
}

static ListDial (struct WM_wwork *wwk)
{
    static char Odev[40] =
    {0};
    char text[84];
    int i, j;
    int pChan;
    PEDITLIST pEd;
    POPTLIST pOpt;
    PLLIST pL;
    PPHONE_LIST pItem;

    i = GetFileName (wwk, "Output to ?", Odev, 40, IO_NEW, 1);

    if (i > 0)
    {
	pChan = io_open (Odev, IO_NEW);
	if (pChan > 0)
	{
	    int kk;
	    int lim;

	    DrawLine (pChan);
	    for (pL = pList; pL; pL = pL->next)
	    {
		pItem = (PPHONE_LIST) pL->item;
		sprintf (text, "%-32s %-40s", pItem->Name, pItem->Phone);

		io_sstrg (pChan, -1, text, (short) strlen (text));
		io_sbyte (pChan, -1, (char) '\n');

		sprintf (text, "%-39s %-39s\n", pItem->Logon, pItem->Comment);
		io_sstrg (pChan, -1, text, (short) strlen (text));

		lim = MAX_OXL;

		for (j = 0, kk = 5; j < lim; j += 5)
		{
		    for (i = 0; i < kk; i++)
		    {
			char *s;

			s = (char *) OptText (pItem, 0, (i + j));
			sprintf (text + i * 12, "%-12s", s);
		    }
		    kk = lim - i;
		    io_sstrg (pChan, -1, text, (short) strlen (text));
		    io_sbyte (pChan, -1, (char) '\n');
		}
		DrawLine (pChan);
	    }
	    io_sbyte (pChan, -1, (char) FF);
	    io_close (pChan);
	}
    }
}

static
 DrawLine (pChan)
int pChan;
{
    int i;

    for (i = 0; i < 80; i++)
    {
	io_sbyte (pChan, -1, (char) '-');
    }
    io_sbyte (pChan, -1, (char) '\n');
}

MenuDial (struct WM_wwork *wwk)
{
    int n;
    int xsize = 0, ysize = 0;
    
    n = MakeSList ();

    if(n == 0)
    {
        xsize = 300;
    }

    if(n < 10)
    {
        ysize = 100;
    }

    menu (wwk, "Phone Book", &pScreen, n, 50, 0, xsize, ysize, plitem, 2);
    FreeXList (&pScreen);
    return 0;
}

static long MCOMMAND (struct WM_wwork *wwk, struct WM_menw *mw, char *mst, short col, short row)
{
    struct WM_mobj *mobj;
    int opt;
    int i;

    mobj = mw->rowl[row].rows;
    pb_entry = mobj->item;

    for (i = 0; i < DMITEMS; i++)
    {
	Dm[i].status = WSI_AVBL;
    }


    wwk->wstat->litem[RETITM] = -1;

    if (wwk->wstat->kprs == K_DO)
    {
	DMDIAL (wwk, mw, mst, col, row);
	opt = DM_DIAL;
    }
    else
    {
        LLIST *dm = _DmMenu_;
	opt = menu (wwk, "Phone Actions", &dm, DMITEMS, 50, 50, 160, 0, dlitem, 1);
    }
    if (opt == DM_DIAL)
    {
	return PT__CAN;
    }
    else if ((opt == DM_OPEN) || (opt == DM_ZAP) ||
	     (opt == DM_ADD) || (opt == DM_EDIT))
    {
	return PT__WMOV;
    }

    mst[mobj->item] = WSI_MKAV;
    wm_mdraw (wwk, (struct WM_swdef *) mw, -1);
    mst[mobj->item] = WSI_AVBL;

    return 0;
}
static long LCOMMAND (struct WM_wwork *wwk, struct WM_litm *li)
{
    int i, v = 0;
    int opt;
    LLIST *dm = _DmMenu_;
    for (i = DM_ADD; i < DMITEMS; i++)
    {
	Dm[i].status = WSI_AVBL;
    }
    Dm[0].status = Dm[1].status = Dm[2].status = WSI_UNAV;
    wwk->wstat->litem[RETITM] = -1;
    opt = menu (wwk, "Phone Actions", &dm, DMITEMS, 50, 50, 160, 0, dlitem, 1);

    if (opt == DM_OPEN || opt == DM_ADD)
    {
	v = PT__WMOV;
    }

    lit_reset (wwk, li->item);
    return v;
}

static long MESC (struct WM_wwork *wwk, struct WM_litm *li)
{
    wwk->wstat->litem[RETITM] = -1;
    lit_reset (wwk, li->item);
    return PT__CAN;		/* and return CAN event */
}

static long DMSAVEAS (struct WM_wwork *wwk, struct WM_menw *mw, char *mst, short col, short row)
{
    struct WM_mobj *mobj;
    int n;

    wwk->wstat->litem[RETITM] = DM_SAVEAS;
    n = GetFileName (wwk, "Phone Book File", Qbook_dat, 40, IO_NEW, 1);
    if (n > 0)
    {
	SaveList (1);
	bSave = 0;
    }
    return PT__CAN;
}

static long DMSAVE (struct WM_wwork *wwk, struct WM_menw *mw, char *mst, short col, short row)
{
    struct WM_mobj *mobj;
    int n;

    wwk->wstat->litem[RETITM] = DM_SAVE;
    SaveList (1);
    bSave = 0;
    return PT__CAN;
}

static long DMOPEN (struct WM_wwork *wwk, struct WM_menw *mw, char *mst, short col, short row)
{
    struct WM_mobj *mobj;
    int n;

    n = GetFileName (wwk, "Phone Book", Qbook_dat, 40, IO_OLD, 1);
    if (n > 0)
    {
	wwk->wstat->litem[RETITM] = DM_OPEN;
	BuildList (wwk);
	MakeSList ();
	bSave = 0;
    }
    else
    {
	wwk->wstat->litem[RETITM] = -1;
    }
    return PT__CAN;
}

static long DMDIAL (struct WM_wwork *wwk, struct WM_menw *mw, char *mst, short col, short row)
{
    struct WM_mobj *mobj;
    int n;

    DialModem (pb_entry);

    wwk->wstat->litem[RETITM] = DM_DIAL;
    return PT__CAN;
}

static long DMZAP (struct WM_wwork *wwk, struct WM_menw *mw, char *mst, short col, short row)
{
    rem_node (&pList, pb_entry);
    FreeXList (&pScreen);
    MakeSList ();
    bSave = 1;
    wwk->wstat->litem[RETITM] = DM_ZAP;
    return PT__CAN;
}

static long DMEDIT (struct WM_wwork *wwk, struct WM_menw *mw, char *mst, short col, short row)
{
    int n = 0;

    n = EditDPage (wwk, pb_entry);

    if (n)
    {
	FreeXList (&pScreen);
	MakeSList ();
	bSave = 1;
	wwk->wstat->litem[RETITM] = DM_EDIT;
    }
    else
    {
	wwk->wstat->litem[RETITM] = -1;
    }
    return PT__CAN;
}

static long DMADD (struct WM_wwork *wwk, struct WM_menw *mw, char *mst, short col, short row)
{
    int n = 0;

    n = EditDPage (wwk, -1);

    if (n)
    {
	FreeXList (&pScreen);
	MakeSList ();
	bSave = 1;
	wwk->wstat->litem[RETITM] = DM_ADD;
    }
    else
    {
	wwk->wstat->litem[RETITM] = -1;
    }
    return PT__CAN;
}

static long DMLIST (struct WM_wwork *wwk, struct WM_menw *mw, char *mst, short col, short row)
{
    wwk->wstat->litem[RETITM] = DM_LIST;

    ListDial (wwk);

    return PT__CAN;
}
