/*
 * $Log: pqem.c,v $
 * Revision 1.10  1998/06/12 20:03:01  jrh
 * Fixed -i bug
 *
 * Revision 1.9  1998/01/18 18:54:20  jrh
 * for 1.63 release
 *
 * Revision 1.8  1997/08/23 21:11:08  jrh
 * pre config removal
 *
 * Revision 1.7  1997/04/13 16:52:25  jrh
 * 1.624 release
 *
 * Revision 1.6  1996/12/23 22:32:50  jrh
 * Checkin for 1.62
 *
 * Revision 1.5  1996/07/09  09:22:56  jrh
 * pre file sel 1.599
 *
 * Revision 1.4  1996/01/19  13:23:56  root
 * Revised for 1.57
 *
 * Revision 1.3  1995/12/30  18:28:09  root
 * For v1.57 (QXL baud, SH status, CSM crash)
 *
 * Revision 1.2  1995/11/12  15:29:37  root
 * OS checking
 *
 * Revision 1.1  1995/09/16  17:22:18  root
 * Initial login under Linux
 *
 * Revision 1.12  1995/05/31  17:05:26  jrh
 * No CR option and new XPR (nothing)
 *
 * Revision 1.11  1995/04/17  22:00:45  jrh
 * Things & fix local lockup
 *
 * Revision 1.10  1995/04/08  20:53:27  jrh
 * Add Thing functionality
 *
 * Revision 1.9  1995/03/27  21:58:47  jrh
 * Serialise startup jobs
 *
 * Revision 1.8  1995/03/24  17:27:16  jrh
 * Tidy up initialisations
 *
 * Revision 1.7  1995/03/24  16:29:31  jrh
 * Fix Wait and Dial script bugs
 *
 * Revision 1.6  1995/03/13  22:13:34  jrh
 * Added init/exit scripting
 *
 * Revision 1.5  1995/03/12  23:00:08  jrh
 * scripting
 *
 * Revision 1.4  1995/02/12  18:03:25  jrh
 * beta for scripting
 *
 * Revision 1.3  1994/12/22  17:55:07  jrh
 * Sort out local & graphics at EOL
 *
 * Revision 1.2  1994/12/15  21:31:12  jrh
 * various changes
 *
 * Revision 1.1  1994/05/30  21:43:13  jrh
 * Initial checkin at v1.33
 *
 */

static char rcsid[] = "$Id: pqem.c,v 1.10 1998/06/12 20:03:01 jrh Exp $";

#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <qptr.h>

#include "defs.h"

Prototype QeMInit (int, char **);
Prototype QTPI_Go ();

static void SerJob (void);

void SerRead ();
void QeMClk ();

extern int QPTR_VERS;
extern char mono;
extern short iconic;

#define HOSTMON 8

TUNEBLK QT = {16, 8, 0, 1, 8};

#define SBUFSIZ 16384
#define SBUFMIN  1280

static char *CheckArg (char ***pav, int *pac);

extern void *GetXPRData(void);
extern short zDelay;

static int FrigRead(int wait, char *buf, int limit, int *got)
{
   int j; 
   j = io_fstrg (pS->pSerId, wait, (char *) buf, limit);
   if (j > 0)
   {
       *got = j;
       j = 0;
   }
   else
   {
       *got = 0;
   }
   
   return j;
}

QeMInit (int ac, char **av)
{
    USHORT sv;
    char *Qb;

    pS = GetpS ();

    if(GetXPRData () == NULL)
    {
        mt_frjob(-1, -9);
    }

    if ((Qb = getenv ("QTPI_DATA")) && *Qb)
    {
	strcpy (QeM_Dat, Qb);
    }

    while (++av, --ac)
    {
	char *p;

	if (**av == '-')
	{
	    switch (*++(*av))
	    {
		case 'p':
		    if(p = CheckArg(&av, &ac))
		    {
			QT.Sprio = atoi(p);
		    }
		    break;
		case 'd':
		    if(p = CheckArg(&av, &ac))
		    {
			dbflag = atoi(p);
		    }
		    break;
		case 'c':
		    if(p = CheckArg(&av, &ac))
		    {
			scrX = atoi(p);
		    }
		    break;
		case 'h':
		    hflag ^= 1;
		    break;
		case 'm':
		    mono ^= 1;
		    break;
		case 'f':
		    useFS ^= 1;
		    break;
		case 's':
		    if ((p = CheckArg (&av, &ac)) != NULL)
		    {
			strcpy (QeM_Dat, p);
		    }
		    break;
		case 't':
		    if ((p = CheckArg (&av, &ac)) != NULL)
		    {
			strcpy (Qbook_dat, p);
		    }
		    break;
		case 'i':
		    iconic = 1;
		    break;
		case 'z':
		    if(p = CheckArg(&av, &ac))
		    {
			zDelay = atoi(p);
		    }
		    break;
	    }
	}
    }
}

short serstat = 0;

QTPI_Go ()
{
    char *Qb;
    int i;

    /*
     * Create Serial Job, any wait until it gets to after SRVTHG
     * If SRVTHG, then run script
     */

    SerJID = jcall (SerJob, "<QTPI Terminal>", 8, 6000, 0, NULL);

    while (serstat == 0)
    {
	mt_susjb (-1, 2, NULL);
    }

    QTInit ();

    SetupInit ();

    dbflag &= (unsigned short) ~4;

    {
	if ((Qb = getenv ("QEM_BUFFER")) != NULL && *Qb)
	{
	    i = ASCIIParam (Qb, SBUFMIN, 0x1000000, SBUFSIZ);
	}
	else if (*DBuffer)
	{
	    i = ASCIIParam (DBuffer, SBUFMIN, 0x1000000, SBUFSIZ);
	}
	else
	{
	    i = SBUFSIZ;
	}
	
	pS->Addr = xmalloc ((unsigned long) i);
	
	pS->Buff = pS->Addr;
	pS->Size = i;
	pS->Count = 0;
	pS->xoff = i - (i / 16);
	pS->xon = i / 4;
	sprintf (DBuffer, "%d", i);

	pS->Pid = jcall (SerRead, "<QTPI Serial Handler>",
			 (bLocal & 1) ? 0 : QT.Sprio, 600, 1, pS);
    /*
     * Now just release Serial JOB
     */
    }
    ClkPID = jcall (QeMClk, "<QTPI Clock>", 1, 256, 1, qC);
    SrvStats("Idle");
}

extern short StartServer (void);
extern void PollServer (void);
short Iserve = 0;

static void SerJob (void)
{
    int i = 0, j = 0, k = 0;
    unsigned char ch;
    int iwait;
    unsigned char buffer[20];
    int ss;
    
    
    i = StartServer ();

    ss = serstat = 1;

    if (i == -19)		/* not imp == too many !! */
    {
	mt_frjob (QTpid, -9);
    }

    Iserve = (0 == i);
    
    while (1)
    {
      plugh:
        
	if (serstat == 2)
	{
	    iwait = (bLocal & 1) ? 1 : 5;
	    if (pSendId > 0)
	    {
		DoSendFile ();
		iwait = 0;
	    }
	}
	if (Iserve)
	{
	    PollServer ();
	}
    localloop:
	if (serstat == 2)
	{
	    if (bLocal & 1)
	    {
		j = io_fstrg (pDummy, iwait, (char *) buffer, 16);
		if (j <= 0)
		{
		    goto plugh;
		}
		else
		{
		    k = j;
		    j = 0;
		}
	    }
	    else if (serstat == 2)
	    {
		j = (*pS->ReadQue) (iwait, (char *) buffer, 16, &k);
	    }
	    
	    if (j < -1 || pS->SerSts != 0)
	    {
		if(serstat == 2)
		{
		    beep (5000, 10);
		    QErr ("CONNECTION BROKEN", pS->SerSts);
		    SetSerial (1);
		}
		goto plugh;
	    }

	    while (Blocked)
	    {
		mt_susjb (-1, 10, NULL);
	    }

	    if (j == 0)
	    {
		if (ScreenMode)
		{
		    if (ScreenMode < 3)
		    {
			ScreenMode = 8;
			ScreenStat ();
		    }
		}

		for (i = 0; i < k; i++)
		{
		    ch = *(buffer + i);
		    if (XPRStatus & HOSTMON)
		    {
			if ((DO_XPR = XPRMon (ch)))
			{
			    Blocked = 1;
			    pick (pChId, -1, QTpid, K_WAKE);
			    while (Blocked)
			    {
				mt_susjb (-1, 25, NULL);
			    }
			    goto plugh;
			}
		    }
		    ProcessSerial (ch);
		}
	    }
	    else
	    {
		if (ScreenMode)
		{
		    if (ScreenMode > 1)
		    {
			ScreenMode--;
			ScreenStat ();
		    }
		}
	    }
            if(bLocal & 1 && k > 0)
            {
                goto localloop;
            }
	}	
	else
	{
	    mt_susjb (-1, 2, NULL);
	}
    }
}

static char *CheckArg (char ***pav, int *pac)
{
    char *p;
    char **av;

    av = *pav;

    if (*++(*av))
    {
	p = *av;
    }
    else if (*(av + 1) && **(av + 1) != '-')
    {
	p = *++av;
	*pac = *pac - 1;
    }
    else
    {
	p = NULL;
    }
    *pav = av;
    return p;
}

