/*
 * $Log: pqmenu.c,v $
 * Revision 1.3  1997/08/23 21:13:39  jrh
 * pre config removal
 *
 * Revision 1.2  1995/12/30 18:28:09  root
 * For v1.57 (QXL baud, SH status, CSM crash)
 *
 * Revision 1.1  1995/09/16  17:22:18  root
 * Initial login under Linux
 *
 * Revision 1.9  1995/03/31  12:21:52  jrh
 * Fix mallocs to use xmalloc
 *
 * Revision 1.8  1995/03/28  18:30:06  jrh
 * Dial changes for scripting
 *
 * Revision 1.7  1995/03/27  21:58:47  jrh
 * Serialize dial status
 *
 * Revision 1.6  1995/03/12  23:00:08  jrh
 * scripting
 *
 * Revision 1.5  1995/02/12  18:17:51  jrh
 * scripting beta
 *
 * Revision 1.4  1994/12/22  17:55:07  jrh
 * Sort out local & graphics at EOL
 *
 * Revision 1.3  1994/12/15  21:31:12  jrh
 * menu changes
 *
 * Revision 1.2  1994/05/31  22:19:55  jrh
 * Additional options for connect logic
 *
 * Revision 1.1  1994/05/30  21:43:23  jrh
 * Initial checkin at v1.33
 *
 */

static char rcsid[] ="$Id: pqmenu.c,v 1.3 1997/08/23 21:13:39 jrh Exp $";

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>
#include <qdos.h>
#include <qlib.h>
#include <qptr.h>

#include "defs.h"

#define DIAL         0
#define DISCONNECT   1
#define CONNECT      2
#define ANSWER       3
#define AUTOANSWER   4
#define RESET        5
#define TEST         6
#define TEXTEST      (TEST-1)

#define UPLOAD       SEND
#define DOWNLOAD     RECEIVE
#define PROTOCOL     5
#define XOPTIONS     6
#define LSEND        4
#define LCAP         3


Prototype OnModemMenu (struct WM_wwork *, int);
Prototype DoCaptureItem (void *, short, short);
Prototype int DoSendItem (void *, short);
Prototype char *CheckPhone (char *);
Prototype int SetDial (char *);
Prototype DoDefLog (void);
Prototype OpenCapFile (CAPDEF_t *, char *);
Prototype ScreenStat (void);
Prototype CloseCapFile (CAPDEF_t *);
Prototype CloseSendFile (void);
Prototype MakeCapBuff (CAPDEF_t *);
Prototype ReDial (char *);

LOCAL UCHAR Qmode[] = {0, 16, 32, 48, 64};

LOCAL int pWin3 = 0;

LOCAL char et[] = {64, 55};

static char preset[64] = {0};

/**************
 * New bits   *
 *************/

LOCAL int LogTime;
static char MyCapFile[64] = {0};
static char MySendFile[64] = {0};

OnModemMenu (struct WM_wwork *wwk, int Option)
{
    UCHAR Qcmd[80];
    UCHAR *Hcmd;
    int Clen = 0;
    int rval = 0;

    Hcmd = NULL;
    Qcmd[0] = USC;

    switch (Option)
    {
	case DIAL:
	    Clen = menu_text (wwk, "Phone Number", pPhoneNo, 40L);
	    if (Clen > 0)
	    {
		Clen = SetDial ((char *) Qcmd);
		pAnswer = NULL;
                Hcmd = Qcmd;
	    }
	    else
	    {
		Clen = 0;
		rval = -1;
	    }
            *preset = 0;
	    break;

	case DISCONNECT:
            GoOffLine();
	case ANSWER:
	case AUTOANSWER:
            qC->qState = Q_DIAL;
	case CONNECT:
            strcpy ((char *) Qcmd, MdmCtrl[Option - 1]);
	    Hcmd = Qcmd;
	    Clen = 0;
	    break;

	case RESET:
            strcpy ((char *) (Hcmd = (Qcmd + Clen)), MdmCtrl[Option - 1]);
	    break;

	case TEST:
	    AboutQTPI (wwk, 1, NULL);
            strcpy ((char *) (Hcmd = (Qcmd + Clen)), MdmCtrl[TEXTEST]);
	    break;
	default:
	    Clen = 0;
	    break;
    }

    if (Hcmd)
    {
	if (Clen)
	{
	    mt_susjb (-1, 25, NULL);
	}
	ParseString ((char *) Hcmd, (int (*)(char, char **))pS->SendChr, 1, NULL);
    }

    return rval;
}

DoCaptureItem (void * wwk, short item, short flag)
{
    int Clen;

    nCapture = 0;
    if (Cap.chid == 0)
    {
        if(*MyCapFile == 0)
        {
	    if(*CapFile == 0)
	    {
		strcpy(CapFile, DefLog);
	    }
            strcpy(MyCapFile, CapFile);
        }
        if(flag)
        {
	    Clen = GetFileName ((struct WM_wwork *) wwk, "Capture File", MyCapFile, 63, IO_NEW, FALSE);
        }
        else
        {
            strcpy(MyCapFile, (char *) wwk);
        }
	if (Clen > 0)
	{
	    OpenCapFile (&Cap, MyCapFile);
            if(Cap.chid > 0)
            {
	        if(item)
	        {   
	            Cap.pos = Cap.size;
	        }
	        else
	        {
	            Cap.pos = 0;
	            if(Cap.wrap)
	            {
                        int mnext, n;
                        mnext = Cap.size + 1;
                        if(mnext == Cap.max)
                        {
                            mnext = 0;
                        }
                        fs_save (Cap.chid, Cap.buf + mnext, (n = Cap.max - mnext));
	            }
	        }
	    }
	    else
	    {
	        Cap.chid = 0;
	    }
	}
    }
    else
    {
	CloseCapFile (&Cap);
    }
    return Clen;
}

int DoSendItem (void * wwk, short inter)
{
    int Clen = 0;

    if (pSendId == 0)
    {
        if(*MySendFile == 0)
        {
            strcpy(MySendFile, SendFile);
        }
        if(inter)
        {
	    Clen = GetFileName ((struct WM_wwork *) wwk, "Send Text", MySendFile, 39, IO_OLD, TRUE);
	}
	else
	{
	    strcpy(MySendFile, (char *) wwk);
	    Clen = strlen(MySendFile);
	}
	if (Clen > 0)
	{
	    pSendId = io_open (MySendFile, IO_OLD);
	    if (pSendId < 0)
	    {
		QErr (MySendFile, pSendId);
		pSendId = 0;
		Clen = -1;
	    }
	    else
	    {
		sptr = sbuf = xmalloc ((size_t) 4096);
		ssize = 0;
		lStatus |= LSEND;
		DoStatus ();
	    }
	}
    }
    else
    {
	CloseSendFile ();
    }
    return Clen;
}

char *CheckPhone (char *p)
{
    static char pbuf[64];
    char *q;

    for (q = pbuf; *p; p++)
    {
	if (*p == '[')
	{
	    strcpy (q, ApresDial);
	    q = strchr (q, '\0');
	}
	else
	{
	    *q++ = *p;
	}
    }
    *q = '\0';
    return pbuf;
}

int SetDial (char *pCmd)
{
    extern void SetString(char *);
    
    int Clen;
    char *p;

    QCInit ();
    p = CheckPhone (pPhoneNo);
    strcpy (pCmd, PreDial);
    if(wBaud > 1200)
    {
        strcat(pCmd, "\\|");
    }
    strcat (pCmd, p);
    strcat (pCmd, PostDial);
    SetString(MdmCtrl[6]);
    qC->qState = qC->dState = Q_DIAL;
    qC->dTime = time (NULL) + qC->dWait;
    bEnq = 1;

    DoDialJob = (qC->qJobId == 0);
    return 0;
}
DoDefLog (void)
{
    if (Cap.chid > 0)
    {
	CloseCapFile (&Cap);
    }
    else if (DefLog[0])
    {
	OpenCapFile (&Cap, DefLog);
    }
}
OpenCapFile (CAPDEF_t *c, char *filnam)
{
    c->chid = io_open (filnam, 0);
    if (c->chid > 0)
    {
        fs_pos (c->chid, 0x007fffff, 0);
    }
    else
    {
	c->chid = io_open (filnam, 3);
    }
    
    if (c->chid > 0)
    {
	time_t t;
	char text[80], ttxt[32];
        int n;
        
        /* We use QL format times here because it makes the program
         *  over 2700 bytes smaller !!!!!
	 */

        t = mt_rclck();
    
	LogTime = t;
        cn_date(ttxt, t);
	sprintf (text, "\n++ %s log opened %-20.20s\n\n", 
		 c->name, ttxt+2);
	n = io_sstrg (c->chid, -1, text, (short) strlen (text));

	if(c == &Cap)
	{
	    lStatus |= bCapture;
	    bCapture = 1;
	    DoStatus ();
	}
    }
    else
    {
	QErr (filnam, c->chid);
	c->chid = 0;
	if(c == &Cap) bCapture = 0;
    }
}

ScreenStat (void)
{
    extern char mono;
    static struct QLRECT qlr = {5, 10, 1, 1};
/*                  colour,stat    */
    static char scol[2][2] = {  
                                {GREEN,RED},
                                {BLACK,WHITE}
    };
    short off;
    off = (ScreenMode < 3);
    sd_fill (pStId, -1, scol[mono & 1][off & 1], &qlr);
}



CloseCapFile (CAPDEF_t *c)
{
    char text[80], ttxt[32];
    time_t t;
    int h, m, s;

    if(c == &Cap)
    {
	lStatus &= ~bCapture;
	bCapture = 0;
    }
    FlushCapBuf(c);
    t = mt_rclck();
 
    LogTime = t - LogTime;
    h = LogTime / 3600;
    m = (LogTime / 60) % 60;
    s = LogTime % 60;
    cn_date(ttxt, t);
    sprintf (text, "\n-- %s log closed (%02d:%02d:%02d) %-20.20s\n", 
	     c->name, h, m, s, ttxt+2);

    io_sstrg (c->chid, -1, text, (short) strlen (text));
    io_close (c->chid);
    c->chid = 0;
    DoStatus ();
}
CloseSendFile (void)
{
    lStatus &= ~LSEND;
    if (sbuf)
    {
	xfree (sbuf);
	sbuf = NULL;
    }
    io_close (pSendId);
    pSendId = 0;
    DoStatus ();
}

MakeCapBuff (CAPDEF_t *c)
{
    int n = c->mem;

    c->size = c->max = c->pos = c->wrap = 0;
    for (; n > 256; n = n >> 1)
    {
	if ((c->buf = xmalloc ((size_t) n)) != NULL)
	{
	    break;
	}
    }
    if (c->buf)
    {
	c->max = n;
        c->new = 0;
        AddCapBuff(c, '\n');
        c->new = 1;
    }
}
ReDial (char *Init)
{
    int i;
    char Qcmd[64];

    i = SetDial (Qcmd);

    if (Init && *Init)
    {
	ParseString (Init, (int (*)(char, char **))pS->SendChr, 1, NULL);
	strcpy (preset, Init);
    }
    else if (Init && *preset)
    {
	ParseString (preset, (int (*)(char, char **))pS->SendChr, 1, NULL);
    }
    else
    {
	*preset = '\0';
    }

    ParseString (Qcmd, (int (*)(char, char **)) pS->SendChr, 1, NULL);
}
