/*
 * $Log: pqproc.c,v $
 * Revision 1.10  1998/01/18 18:54:20  jrh
 * for 1.63 release
 *
 * Revision 1.9  1997/08/23 21:11:08  jrh
 * pre config removal
 *
 * Revision 1.8  1997/04/13 16:53:34  jrh
 * cursor and console changes
 *
 * Revision 1.7  1996/12/23 22:32:52  jrh
 * Checkin for 1.62
 *
 * Revision 1.6  1996/07/10  12:16:04  jrh
 * Move and redraw
 *
 * Revision 1.5  1996/07/09  09:25:14  jrh
 * pre-file sel (1.599)
 *
 * Revision 1.4  1996/01/19  13:23:56  root
 * Revised for 1.57
 *
 * Revision 1.3  1995/11/26  14:29:04  root
 * v156
 *
 * Revision 1.2  1995/11/12  15:29:37  root
 * OS checking
 *
 * Revision 1.1  1995/09/16  17:22:18  root
 * Initial login under Linux
 *
 * Revision 1.14  1995/05/31  17:03:57  jrh
 * No CR option and new XPR (nothing)
 *
 * Revision 1.13  1995/05/13  11:23:23  jrh
 * Final 1.53 revision
 *
 * Revision 1.12  1995/04/03  21:10:27  jrh
 * Add the missing CR !!!
 *
 * Revision 1.11  1995/03/31  12:21:52  jrh
 * Fix mallocs to use xmalloc
 *
 * Revision 1.10  1995/03/18  12:34:53  jrh
 * preparation for Viewdata
 *
 * Revision 1.9  1995/03/13  22:13:34  jrh
 * Added init/exit scripting
 *
 * Revision 1.8  1995/03/12  23:00:08  jrh
 * scripting
 *
 * Revision 1.7  1995/02/12  18:13:17  jrh
 * Scripting beta
 *
 * Revision 1.6  1995/02/05  16:56:05  jrh
 * Extra delay (\+) for Dave Woodman
 *
 * Revision 1.5  1994/12/25  13:40:54  jrh
 * Change to ANSI (VT52, ESC<)
 *
 * Revision 1.4  1994/12/22  17:55:07  jrh
 * Sort out local
 *
 * Revision 1.3  1994/12/15  21:31:12  jrh
 * 80 Col updates
 *
 * Revision 1.2  1994/07/09  15:34:29  jrh
 * Changes for better vt100
 *
 * Revision 1.1  1994/05/30  21:43:14  jrh
 * Initial checkin at v1.33
 *
 */


static char rcsid[] ="$Id: pqproc.c,v 1.10 1998/01/18 18:54:20 jrh Exp $";

#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <time.h>
#include <pd/csrvthg.h>
#include "defs.h"

#ifndef CSF5
#define CSF5 251
#endif
#ifndef SF4
#define SF4 246
#endif

#ifndef SCAPS
#define SCAPS 0xe4
#endif
#ifndef CSCAPS
#define CSCAPS 0xe6
#endif

Local char *vtXlate (UCHAR);

Prototype ProcessKeys (unsigned char);
Prototype VT52Esc (char);
Prototype AddEscBuffer (char);
Prototype DoEscSeq ();
Prototype ProcessNorm (UCHAR);
Prototype DoSendFile ();
Prototype AddCapBuff (CAPDEF_t*, char);
Prototype FlushCapBuf (CAPDEF_t *);
Prototype QTInit ();
Prototype SetupInit ();
Prototype QShut (struct WM_wwork *, short);
Prototype void ParseString (char *, int (*)(char, char **), int, char **);
Prototype CanSub (char);
Prototype SoundOff (int);
Prototype DoMiscAct (int);
Prototype PlayItAgainSam(short);

extern struct WM_wwork *Main_ww;
extern  int RunScript(char *, short, char *);

LOCAL char *pEOLText[] = {"\012", "\015", "\015\012"};
LOCAL char *vtXlate (UCHAR);
LOCAL short jSwap;
LOCAL UCHAR bCR = FALSE;
static unsigned int kmask[8] = {0};
static short nKeys = 0;
#ifdef VDATA
LOCAL char *viewXlate(UCHAR);
#endif
char nbs = 0;
static unsigned short xBaud;

FlushCapBuf (CAPDEF_t *c)
{
    int res = 0;

    if (c->chid > 0 && c->buf && c->size > 0)
    {
	res = fs_save (c->chid, c->buf + c->pos, c->size - c->pos);
	c->pos = 0;
    }

    return res;
}
UCHAR Xlate7(UCHAR ch)
{
    if(ch > 159 && ch < 192)
    {
        ch = ch - 160;
    }
    return (ch & 0x7f);
}

ProcessKeys (UCHAR ch)
{
    char *pSerChar = NULL;
    char SerText[2];
    
    if (bErrMsg)
    {
	bErrMsg = FALSE;
	DoStatus ();
    }

    if(okey && (ch == okey))
    {
	oflag ^= 1;
	DoStatus ();
	return 0;
    }

    SerText[1] = '\0';

    if (ch == DELETE)
    {
	ch = bDelChar;
    }
    else if (ch == LF)
    {
	pSerChar = pEOLText[bTXEOL];
    }
    else if (ch != CR)
    {
#ifdef VDATA
        if (bEmulation == VIEWD)
        {
            pSerChar = viewXlate(ch);
        }
        else
#endif
	pSerChar = vtXlate (ch);
    }
    
    if (pSerChar == NULL)
    {
        if(key7)
        {
            ch = Xlate7(ch);
        }

	pSerChar = SerText;
	SerText[0] = ch;
    }

    if (pSerChar && pS->pSerId)
    {
	(*pS->SendStr) (pSerChar);
	if(pSerChar[0] == '\033' && pSerChar[1] == '[' && pSerChar[2] == 0)
	{
	    (*pS->SendChr) ('\0');
	}
	
	if (bLocal == 2 || bLocal == 1)
	{
	    unsigned char *p;

	    for (p = (unsigned char *) pSerChar; *p; p++)
	    {
		if (*p == bDelChar)
		{
		    ProcessSerial ('\b');
		    ProcessSerial (' ');
		    ProcessSerial ('\b');
		}
		else
		{
		    ProcessSerial (*p);
		}
	    }
	}
    }
}

VT52Esc (char ch)
{
    *pEscBuf++ = ch;
    if (ch == 'Y')
    {
	sState = SESCP1;
    }
    else
    {
	sState = SESCEX;
    }
}

AddEscBuffer (char ch)
{
    
    if ((unsigned char)ch > 127 || ch < 32 ||
	ch == CAN || ch == SS || ch == ESC)
    {
	CanSub (ch);
    }
    else
    {
	*pEscBuf++ = ch;

	switch (sState)
	{
	    case SESCNO:
	    case SESCGx:
		sState = SESCEX;
		break;

	    case SESCP1:
		sState = SESCP2;
		break;

	    case SESCP2:
		sState = SESCEX;
		break;

	    case SESCPM:
		if (ch > 63)
		{
		    sState = SESCEX;
		}
		break;
	}
    }
}

DoEscSeq ()
{
    *pEscBuf = '\0';
    if (bEmulation == VT52)
    {
	switch (EscBuf[0])
	{
	    case 'A':
		sd_prow (pChId, -1);
		break;
	    case 'B':
		sd_nrow (pChId, -1);
		break;
	    case 'C':
		sd_ncol (pChId, -1);
		break;
	    case 'D':
		sd_pcol (pChId, -1);
		break;
	    case 'F':
		vtMode = 1;
		break;
	    case 'G':
		vtMode = 0;
		break;
	    case 'H':
		sd_pos (pChId, -1, 0, 0);
		break;
	    case 'I':
		ScrollTop ();
		break;
	    case 'J':
		sd_clrrt (pChId, -1);
		sd_clrbt (pChId, -1);
		break;
	    case 'K':
		sd_clrln (pChId, -1);
		break;
	    case 'U':
		break;
	    case 'W':
		break;
	    case 'X':
		break;
	    case 'Y':
		sd_pos (pChId, -1, EscBuf[2] - 32, EscBuf[1] - 32);
		break;
	    case 'Z':
                if(bLocal != 1)
                {
		    (*pS->SendStr) ("\033/Z");
	        }
		break;
	    case '=':
	    case '>':
		break;
	    case '<':
        	bEmulation = VT100;
                Setups[SET_EMUL].current = 1;
        	bMaxChar = 80;
		VT100Init (1);
                DoStatus ();
		break;
	    case '^':
	    case '_':
	    case ']':
		break;
	}
    }
    else
    {
	EscVT100 ();
    }
    sState = SNORM;
}

ProcessNorm (UCHAR ch)
{
    
    if (bCR == TRUE)
    {
	if (ch != LF)
	{
	    sd_tab (pChId, -1, 0);
	}
	bCR = FALSE;
    }

    if (ch > 31 || bCtrl)
    {
	if (sCount & 1)
	{
	    if (ch == 0x9B && (bEmulation & ANSI_M) && bShowCSI == 0)
	    {
		pEscBuf = EscBuf;
		VT100Esc ('[');
	    }
	    else
	    {
		if (ch == 96 && (bEmulation & VT100_M))
		{
		    ch = 39;
		}
		WriteChar (ch);
	    }
	}
    }
    else
    {
	if ((bEmulation & DECVT) && (ch == VT || ch == FF))
	{
	    ch = LF;
	}

	switch (ch)
	{
	    case ESC:
		sState = SESC;
		pEscBuf = EscBuf;
		break;

	    case ENQ:
		if (bEnq)
		{
		    mt_susjb (-1, 25, NULL);
		    ParseString (pAnswer, (int (*)(char, char **)) pS->SendChr, 1, NULL);
		    bEnq = 0;
		}
		else
		{
		    OutError ("Duplicate ENQ");
		}
		break;

	    case BS:
                if(nbs == 0)
                {
		    sd_pcol (pChId, -1);
		}
		else
		{
		    nbs--;
		}
		break;

	    case '\007':
		do_sound (1200, 5, 0, 0, 0, 0, 0, 0);
		break;

	    case TAB:
		NextTabStop ();
		break;

	    case CR:
		if (bRXEOL == EOLCR)
		{
		    NewLine ();
		}
		else
		{
		    bCR = TRUE;
		}
		break;

	    case SO:
		vtMode = 1;
		break;

	    case SI:
		vtMode = 0;
		break;

	    case LF:
		if (bRXEOL == EOLLF || (bRXEOL == EOLCRLF && lastch == CR))
		{
		    NewLine ();
		}
		else
		{
		    ReadCsr (pChId, &Xpos, &Ypos);
		    NewLine ();
		    sd_tab (pChId, -1, Xpos);
		}
		break;

	    case VT:
		sd_prow (pChId, -1);
		break;
	    case FF:
		sd_pos (pChId, -1, 0, 0);
		sd_clear (pChId, -1);
		break;
	    case DEL:
		if (bLocal == 1 || bLocal == 2)
		{
		    sd_pcol (pChId, -1);
		    WriteChar (' ');
		    sd_pcol (pChId, -1);
		    break;
		}
		/* else just fall thru */
	    default:
		if (bEmulation & ANSI_M)
		{
		    ANSIAll (pChId);
		    WriteChar (ch);
		    ANSIFont (pChId);
		}
		else
		{
		    WriteChar (ch);
		}
		break;
	}
    }
vdone:
    lastch = ch;
}

LOCAL char *vtXlate (UCHAR ch)
{

#define KP0_ENT 8

    LOCAL XLATES outtable[] =
    {
	{UP, "\033A", "\033[A"},        /*  0 */
	{DOWN, "\033B", "\033[B"},      /*  1 */
	{RIGHT, "\033C", "\033[C"},
	{LEFT, "\033D", "\033[D"},
	{F1, "\033P", "\033OP"},
	{F2, "\033Q", "\033OQ"},
	{F3, "\033R", "\033OR"},
	{F4, "\033S", "\033OS"},
	{KP0, "\033?p", "\033Op"},      /*  8 */
	{KP1, "\033?q", "\033Oq"},
	{KP2, "\033?r", "\033Or"},
	{KP3, "\033?s", "\033Os"},
	{KP4, "\033?t", "\033Ot"},
	{KP5, "\033?u", "\033Ou"},
	{KP6, "\033?v", "\033Ov"},
	{KP7, "\033?w", "\033Ow"},
	{KP8, "\033?x", "\033Ox"},
	{KP9, "\033?y", "\033Oy"},
	{KPCOMMA, "\033?l", "\033Ol"},
	{PULL, "\033?l", "\033Ol"},
	{KPMINUS, "\033?m", "\033Om"},
	{KPDOT, "\033?N", "\033ON"},
	{KPENTER, "\033?M", "\033OM"},
	{0, NULL, NULL}};
    static UCHAR rtemp[128];

    PXLATES ptable;
    UCHAR *pRet = NULL;
    short mode;

    mode = (bEmulation == VT52) ? 0 : 1;

    if(QLmap)
    {
	keymap_t *q;

	for(q = QLmap; q; q = q->next)
	{
	    if(q->qlkey == ch)
	    {
		pRet = (UCHAR *)strcpy((char *)rtemp, q->seq[mode]); 
	    }
	}
    }
    
    if(pRet == NULL)
    {
	
	if(bVTPad == 0)
	{
	    outtable[KP0_ENT].ch = 0;
	}
	else
	{
	    outtable[KP0_ENT].ch = KP0;
	}
	
	for (ptable = outtable; ptable->ch && ptable->ch != ch; ptable++)
	    ;

	if(ptable->ch)
	{
	    pRet = (UCHAR *)strcpy((char *)rtemp, (char *)ptable->pText[mode]);
	    
	    if (mode &&
	        (ch == UP || ch == DOWN || ch == RIGHT || ch == LEFT))
	    {
		short bit8 = ((bEmulation & ANSI_M) && bShowCSI == 0);
		
		if(bVTKmode == NORM)
		{
		    if(bit8)
		    {
			*++pRet = 0x9b;
		    }
		    else
		    {
			*(pRet + 1) = '[';
		    }
		}
		else
		{
		    if(bit8)
		    {
			*++pRet = 0x8f;
		    }
		    else
		    {
			*(pRet + 1) = 'O';
		    }
		}
#if 0
		{
		    static FILE* fp = NULL;
		    char txt[80];
		    char *p;
		    time_t t;
		    
		    if(fp == NULL)
		    {
			fp = fopen("ram2_key_log", "w");
		    }
		    t = time(NULL);
		    p = ctime(&t);
		    *(p+19) = 0;
		    
		    fprintf(fp, "%s Arrow %c%c\n", p+11, *(pRet+1), *(pRet+2));
		    fflush(fp);
		}
#endif
	    }
	}
    }
    return (char *) pRet;
}

DoSendFile ()
{
    char ch = 0;
    int d0 = 0;

    if (sbuf == NULL)
    {
	d0 = io_fbyte (pSendId, -1, (char *) &ch);
    }
    else
    {
	if (ssize == 0)
	{
	    ssize = io_fstrg (pSendId, -1, sbuf, 4096);
	    sptr = sbuf;
	    if (ssize > 0)
	    {
		d0 = 0;
		ch = *sptr++;
		ssize--;
	    }
	    else
	    {
		d0 = -1;
	    }
	}
	else
	{
	    ch = *sptr++;
	    ssize--;
	    d0 = 0;
	}
    }
    if (d0 != 0)
    {
	CloseSendFile ();
    }
    else
    {
	if (ch == LF)
	{
	    (*pS->SendStr) (pEOLText[bTXEOL]);
	    if (bLocal == 2)
	    {
		char *p;

		for (p = pEOLText[bTXEOL]; *p; p++)
		{
		    ProcessSerial (*p);
		}
	    }
	}
	else
	{
	    (*pS->SendChr) (ch);
	    if (bLocal == 2)
	    {
		ProcessSerial (ch);
	    }
	}
    }
}

PlayItAgainSam(short n)
{
    char *ptr, *eptr, *p;
    short eolc = 0;
    short nll;

    nll = (n) ? n : scrY;

    if(bWakeDraw && !Cap.new && (ScreenMode == 0 && (Cap.size || Cap.wrap)))
    {
        Blocked = 1;
        mt_susjb(SerJID, -1, NULL);
        eptr = (Cap.buf + Cap.size);
        ptr = eptr - 2048;
        if(ptr < Cap.buf)
        {
            if(Cap.wrap)
            {
                ptr += Cap.max; 
            }
            else
            {
                ptr = Cap.buf;
            }
        }
        for(eolc = 0, p = eptr; eolc < nll && p != ptr;)
        {
            if(p == Cap.buf)
            {
                p = Cap.buf + Cap.max;
            }
            p--;
            if(*p == '\n')
            {
                eolc++;
            }
            if(*p == '\f')
            {
                p--;
                break;
            }
        }

        if(p != ptr)
        {
            p++;
        }
        
        if(p == Cap.buf+Cap.max)
        {
            p = Cap.buf;
        }
        
        for(ptr = p; ptr != eptr;)
        {
            if(*ptr == '\n' && saveCR == 0 && bRXEOL == EOLCRLF)
            {
                VTDisplay('\r');
            }
            VTDisplay(*ptr);
            ptr++;
            if(ptr == Cap.buf+Cap.max)
            {
                ptr = Cap.buf;
            }
        }
        Blocked = 0;
        mt_reljb(SerJID);
    } 
}

AddCapBuff (CAPDEF_t *c, char ch)
{
    int res;

    if (c->buf)
    {
        if(saveCR || ch != 13)
        {
            if(c->new)
            {
                c->new = 0;
                c->size = 0;
	    }    
            *(c->buf + c->size) = ch;
            c->size++;
            res = 0;
            if (c->size == c->max)
            {
                if(c->chid > 0)
                {
                    res = fs_save (c->chid, c->buf, c->size);
                    c->pos = 0;
	        }
	        c->size = 0;
	        c->wrap = 1;
	    }
	}
    }
}
extern short stackser;

QTInit ()
{
    mt_prior (-1, QT.Qprio);
    bShutDown = FALSE;
    qC->qState = Q_IDLE;

    jSwap = (short) *((short *) ((char *) (_sys_var + 0x92)));
    wRep = (short) *((short *) ((char *) (_sys_var + 0x8C)));
    xBaud = ((*(_sys_var + 0xA0)) & 0x7);

    pSendId = Cap.chid = 0;
    pS->bFlow = 0;
    Cap.maxw = 4+(80*6);
    Xfr.maxw = 4+(64*6);

    Cap.mem = 32*1024;
    Xfr.mem = 4*1024;

    wwFlag = 0;
    pAnswer = NULL;
    okey = oflag = 0;

    Cap.revid = Xfr.revid = 0;

    Cap.name = "QTPI Review";
    Xfr.name = "Xfer Review";

    MakeCapBuff(&Cap);
    MakeCapBuff(&Xfr);
    lStatus = 0;

    qC->qJobId = 0;
    qC->dState = 0;

    XPRPid = 0;
    XPRStatus = Xoption = 0;

    pDummy = 0;
    jScroll = 0;
    DoDialJob = 0;
    ExitParams = NULL;
    if(stackser)
    {
	pS->pSerId = getchid(1);
	pDummy = getchid(0);
    }
    else
    {
	pS->pSerId = 0;
	bLocal = 255;
    }
}

SetupInit ()
{
    char *p;

    if (pRestore () == 0)
    {
	pDefault ();
    }

    if(*StartScript)
    {
        RunScript(StartScript, -1, NULL);
    }

    SetParams (0);

    bSave = 0;
    bConf = 0;

    nKeys = LoadKeys(kmask);    
    BuildList (Main_ww);

    Xpos = Ypos = 0;
    sCount = 1;
    sState = SNORM;
    pEscBuf = EscBuf;
    if(stDoLog[FileSetups[LOG_MODE].current].value)
    {
        DoDefLog();
    }

    if(*XfrFile)
    {
	OpenCapFile (&Xfr, XfrFile);
    }
}

TestFiles(struct WM_wwork *wwk, int flag, char *prompt, 
	  int (*func)(), short def)
{
    int n = 0;
    if(flag)
    {
        n = menu_choice(wwk, prompt, 3, def,"Save","Don't Save","Go Back");
        switch(n)
        {
            case 0:
                (*func)(0);
            case 1:
                n = 0;
                break;
        }
    }
    return n;
}
int QShut (struct WM_wwork *wwk, short flag)
{
    int n = 0;
    extern short serstat,iconic;
    if(flag == 0 && !iconic)
    {
	if(conf2 > 2) conf2 = 2; 
        n = TestFiles(wwk, bSave, "Save changes to phone book ? ", SaveList, 
		      conf2);
    }
    if(n == 0)
    {
        if(flag == 0 && !iconic)
        {
	    if(conf1 > 2) conf1 = 2; 
            n = TestFiles(wwk, bConf, "Save changes to Config ? ", pSave, 
			  conf1);
        }
        if(n == 0)
        {
	    serstat = 1;
	    if(pS->Pid)
	    {
		mt_frjob (pS->Pid, 0);
	    }
	    if(pDummy == 0)
		io_close (pS->pSerId);

            *((short *) (_sys_var + 0x92)) = (USHORT) jSwap;
            *((short *) (_sys_var + 0x8C)) = (USHORT) wRep;

            if (ExBaud && ExBaud)
            {
		if(ExBaud != 0xffff)
		{
		    mt_baud (ExBaud);
		}
            }
            else
            {
		xBaud = stExSpeed[7 - xBaud].value;
		xBaud = SplitBaud(xBaud);
	        mt_baud (xBaud);
            }
            if (Cap.chid > 0)
            {
	        CloseCapFile (&Cap);
            }
            if (Xfr.chid > 0)
            {
	        CloseCapFile (&Xfr);
            }
            if(nKeys > 0)
            {
                RemoveKeys(kmask);
            }
            XPRKill();

            if(*ShutScript)
            {
                RunScript(ShutScript, -1, ExitParams);
            }

            mt_frjob (SerJID, 0);
            FreeSrvThg(SRVR, "QTPI");
            exit(0);
	}
    }
    return n;
}

void ParseString (char *pString, int (*func)(char, char **), int flag, char **pbf)
{
    char *ptr, *pnBuf;
    char nBuf[4];
    int tmp;
    short ndigit;
    short state = 0;

    if (pString)
    {
	ptr = pString;
        do
	{
	    switch (state)
	    {
		case 0:
		    if (*ptr == '\\')
		    {
			state = 1;
			pnBuf = nBuf;
		    }
		    else
		    {
		        if(*ptr)
		        {
                            if(CDelay)
                            {
                                mt_susjb(-1, CDelay, NULL);
                            }
			    (*func) (*ptr, pbf);
			}
		    }
		    break;
		case 1:
		    if (isdigit ((*ptr)))
		    {
			*pnBuf++ = *ptr;
			state = 2;
			ndigit = 3;
		    }
		    else
		    {
			switch (*ptr)
			{
			    case 'x':
			        state = 2;
			        ndigit = 2;
			        break;
                            case 'u':
                                ParseString (pAnswer, func, flag, pbf);
                                break;
			    case 'a':
				(*func) (7, pbf);
				break;
			    case 'n':
				(*func) ('\n', pbf);
				break;
			    case 'r':
				(*func) ('\r', pbf);
				break;
			    case 't':
				(*func) ('\t', pbf);
				break;
			    case 'b':
				(*func) ('\b', pbf);
				break;
			    case 's':
				(*func) (' ', pbf);
				break;
			    case 'e':
                                {
                                    char *pe;
                                    for(pe = pEOLText[bTXEOL];*pe;pe++)
                                    {
				        (*func) (*pe, pbf);
				    }
				}
				break;
			    case 'f':
				(*func) ('\f', pbf);
				break;
			    case '\\':
				(*func) ('\\', pbf);
				break;
			    case '\'':
				(*func) ( '\'', pbf);
				break;
			    case '~':
			        if(flag)
			        {
				    mt_susjb (-1, 5, NULL);
				}
				break;
			    case '|':
			        if(flag)
			        {
				    mt_susjb (-1, 50, NULL);
				}
                                break;
			    case '+':
			        if(flag)
			        {
				    mt_susjb (-1, 500, NULL);
				}
				break;
			}
                        if(CDelay)
                        {
                            mt_susjb(-1, CDelay, NULL);
                        }

			if(state == 1)
			{
                            state = 0;
                        }
		    }
		    break;
		case 2:
		    if (isxdigit ((*ptr)) && (pnBuf - nBuf) < ndigit)
		    {
			*pnBuf++ = *ptr;
		    }
		    else
		    {
			*pnBuf++ = '\0';
			sscanf (nBuf, (ndigit == 3) ? "%o" : "%x" , &tmp);
			(*func) (tmp, pbf);
                        if(CDelay)
                        {
                            mt_susjb(-1, CDelay, NULL);
                        }
			if (*ptr == '\\')
			{
			    state = 1;
			    pnBuf = nBuf;
			}
			else
			{
			    state = 0;
			    (*func) (*ptr, pbf);
                            if(CDelay)
                            {
                                mt_susjb(-1, CDelay, NULL);
                            }
			}
		    }
		    break;
	    }
	    
	} while (*ptr++);
    }
}

CanSub (char ch)
{
    sState = SNORM;
    if (ch == SS)
    {
	io_sbyte (pChId, -1, 0xb4);
    }
}
SoundOff (int n)
{
    short i;

    for (i = 0; i < n; i++)
    {
	beep (5000, 10);
	mt_susjb (-1, 5, NULL);
    }
}
DoMiscAct (int act)
{
    switch (act)
    {
	case 0:
	    ParseString (pAnswer, (int (*)(char, char **))pS->SendChr, 1, NULL);
	    break;
	case 1:
	    VT100Init (1);
	    break;
	case 2:
	    sd_pos (pChId, -1, 0, 0);
	    sd_clear (pChId, -1);
	    break;
	case 3:
	    if (ScreenMode)
	    {
		ScreenMode = 0;
	    }
	    else
	    {
		ScreenMode = (pS->Count) ? 8 : 2;
		if (csr == 0)
		{
		    csr = 1;
		    PosText ();
		}
	    }
	    DoStatus ();
	    break;
	case 4:
	    ReDial ("");
	    break;
	case 5:
	    DoDefLog ();
	    break;
    }
}
#ifdef VDATA
LOCAL char *viewXlate(UCHAR ch)
{
    char *pret = NULL;

    switch(ch)
    {
        case LEFT:
            pret = "\010";
            break;
        case RIGHT:
            pret = "\011";
            break;
        case DOWN:
            pret = "\012";
            break;
        case UP:
            pret = "\013";
            break;
    }
    return pret;
}
#endif
