/*
 * $Log: pqset.c,v $
 * Revision 1.10  1998/06/12 20:03:01  jrh
 * Fixed -i bug
 *
 * Revision 1.9  1998/01/18 18:54:20  jrh
 * for 1.63 release
 *
 * Revision 1.8  1997/08/23 21:11:08  jrh
 * pre config removal
 *
 * Revision 1.7  1997/04/13 16:54:18  jrh
 * cursor and console changes
 *
 * Revision 1.6  1997/01/04 23:15:30  jrh
 * 1.62 release version
 *
 * Revision 1.5  1996/12/23 22:32:53  jrh
 * Checkin for 1.62
 *
 * Revision 1.4  1996/07/09  09:26:13  jrh
 * pre-file sel (1.599)
 *
 * Revision 1.3  1995/12/30  18:28:09  root
 * For v1.57 (QXL baud, SH status, CSM crash)
 *
 * Revision 1.2  1995/11/12  15:29:37  root
 * OS checking
 *
 * Revision 1.1  1995/09/16  17:22:18  root
 * Initial login under Linux
 *
 * Revision 1.12  1995/05/31  17:03:57  jrh
 * No CR option and new XPR (nothing)
 *
 * Revision 1.11  1995/04/17  22:00:45  jrh
 * Things & fix local lockup
 *
 * Revision 1.10  1995/03/28  18:30:06  jrh
 * Correct CONFIG and SET requests
 *
 * Revision 1.9  1995/03/18  12:34:53  jrh
 * preparation for Viewdata
 *
 * Revision 1.8  1995/03/15  21:41:37  jrh
 * Serial for resume/suspend
 *
 * Revision 1.7  1995/03/12  23:00:08  jrh
 * scripting
 *
 * Revision 1.6  1995/02/12  18:15:22  jrh
 * scripting beta
 *
 * Revision 1.5  1994/12/15  21:31:12  jrh
 * delay for QXL,slow modems
 *
 * Revision 1.4  1994/09/16  17:32:19  jrh
 * Change handling of baud = None
 *
 * Revision 1.3  1994/09/10  15:54:47  jrh
 * Changes QCON Setups
 *
 * Revision 1.2  1994/07/09  15:34:29  jrh
 * Changes for better vt100
 *
 * Revision 1.1  1994/05/30  21:43:16  jrh
 * Initial checkin at v1.33
 *
 */

static char rcsid[] ="$Id: pqset.c,v 1.10 1998/06/12 20:03:01 jrh Exp $";

#ifndef beep
#define beep _beep
#define do_sound _do_sound
#endif

#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <qptr.h>

#include "defs.h"

Prototype int pSave ();
static EDITLIST * ReadParams (char *, EDITLIST *);
Prototype int pRestore ();
Prototype int pDefault ();
Prototype SetParams (int);
Prototype int ASCIIParam (char *, int, int, int);
Prototype QCInit ();
Prototype void SetSerial (int);

extern char *_sys_var;
extern short stackser;

typedef struct QD_text QDS, *PQDS;

static char * PutSetup (PEDITLIST pEd)
{
    POPTLIST pList;
    char *text = NULL;
    static char outp[80];
    char *p = NULL;    

    if (pEd->list)
    {
	if (pEd->type == TOGGLE)
	{
	    pList = ((POPTLIST) pEd->list + pEd->current);
	    text = (char *) ((PQDS) pList->Text)->chrs;
	}
	else if (pEd->type == EDIT || pEd->type == XEDIT)
	{
	    text = (char *) pEd->list;
	}
	if(text)
	{
	    p = strncpy(outp, (char *) ((PQDS) pEd->Title)->chrs, ((PQDS) pEd->Title)->len);
	    p += ((PQDS) pEd->Title)->len;
            *p++ = '=';
            strcpy(p, text);
	}
	else
	{
	    *outp = 0;
	}
    }
    return outp;
}

static PEDITLIST AllSet[] = {Setups, ModemSetups, FileSetups, NULL};

int pSave ()
{
    int fd;
    PEDITLIST pEd, *ptrED;
    char *p;

    bConf = FALSE;

    if ((fd = io_open ((p = QeM_Dat), IO_NEW)) > 0)
    {
	for (ptrED = AllSet; *ptrED; ptrED++)
	{
	    for (pEd = *ptrED; pEd->Title; pEd++)
	    {
		p = PutSetup (pEd);
		io_sstrg(fd, -1, p, strlen(p));
		io_sbyte(fd, -1, '\n');
	    }
	}
	io_close (fd);
    }
    else
    {
	QErr (p, fd);
    }
}

static PEDITLIST ReadParams (char *Text, PEDITLIST pSource)
{
    PEDITLIST pEd, pRet;
    POPTLIST pList;
    char *pTxt;
    char *peq;
    int i;

    pRet = NULL;
    pTxt = strchr (Text, '=');

    if(pTxt)
    {
	peq = pTxt;
	*pTxt++ = '\0';

	for (pEd = pSource; pEd->Title; pEd++)
	{
	    if (pEd->list)
	    {
		size_t nnn;
		nnn = strlen (Text);
		if (nnn == ((PQDS) pEd->Title)->len &&
		    strnicmp (Text, (char *) ((PQDS) pEd->Title)->chrs, nnn) 
		    == 0)
		{
		    if (pEd->type == TOGGLE && *pTxt)
		    {
			for (i = 0, pList = (POPTLIST) pEd->list;
			     pList->Text; pList++, i++)
			{
			    if (strnicmp ((char *) ((PQDS) pList->Text)->chrs, 
					  pTxt, 
					  (size_t) ((PQDS) pList->Text)->len) 
				== 0)
			    {
				if (pEd->current != i)
				{
				    pEd->current = i;
				    pEd->Change = TRUE;
				}
				pRet = pEd;
				break;
			    }
			}
			}
		    else if (pEd->type == EDIT || pEd->type == XEDIT)
		    {
			strcpy ((char *) pEd->list, pTxt);
		    }
		    pRet = pEd;
		    break;
		}
	    }
	}
	*peq = '=';
    }
    return pRet;
}

char * RemGet(char *Text)
{
    PEDITLIST pEd, *ptrED;
    char *p = NULL;
    short done = 0;
    
    for (ptrED = AllSet; !done && *ptrED; ptrED++)
    {
        for (pEd = *ptrED; !done && pEd->Title; pEd++)
	{
    	    if (pEd->list)
            {
	        size_t nnn;
	         nnn = strlen (Text);
                if (nnn == ((PQDS) pEd->Title)->len &&
		    strnicmp (Text, (char *) ((PQDS) pEd->Title)->chrs, nnn) == 0)
		{
    		    p = PutSetup (pEd);
                    done = 1;
                }
            }
	}
    }
    return p;
}

int RemSet(char *Text)
{
    PEDITLIST *ptrEd, pRet;
    
    for (ptrEd = AllSet; *ptrEd; ptrEd++)
    {
        if(pRet = ReadParams (Text, *ptrEd))
        {
            pRet->Change = TRUE;
            SetParams(1);
	    DoStatus();
            break;
        }
    }
    return (int) pRet;
}

int pRestore ()
{
    int fd;
    int retval;
    char Text[80];
    int i;
    char *p;
    PEDITLIST *ptrEd;

    fd = io_open (QeM_Dat, IO_OLD);
    if (fd > 0)
    {
        char *z;
	while ((i = io_fline (fd, -1, Text, (short) sizeof (Text))), i > 0)
	{
            if(*Text == '#')
            {
                continue;
            }
            if((z = strchr(Text, '\n')))
            {
                *z = '\0';
            }
            else
            {
	        Text[--i] = '\0';
	    }

	    for (ptrEd = AllSet; *ptrEd; ptrEd++)
	    {
		retval = (int) ReadParams (Text, *ptrEd);
		if (retval)
		{
		    break;
		}
	    }
	}
	io_close (fd);
	retval = 1;
    }
    else
    {
	retval = 0;
    }
    return retval;
}

int pDefault ()
{
    PEDITLIST pEd;

    for (pEd = Setups; pEd->Title; pEd++)
    {
	if (pEd->list)
	{
	    if (pEd->type == TOGGLE && (pEd->current != pEd->defval))
	    {
		pEd->current = pEd->defval;
		pEd->Change = TRUE;
	    }
	}
    }
}
void CloseSerial(void)
{
    if (pS->pSerId > 0)
    {
        if(pS->Pid)
        {
            mt_susjb (pS->Pid, -1, NULL);
        }
	io_close (pS->pSerId);
	pS->pSerId = 0;
    }
}

unsigned short SplitBaud(unsigned short baud)
{
    if((dbflag & 16) && (specbaud == 11 || specbaud == 13 || 
			specbaud == 28 || specbaud == 30))
    {
	baud |= (stPort[Setups[SET_PORT].current].value - '0');
    }
    return baud;
    
}

/*ser3_b9.6k u16k t u4k*/

void SetBaudRate(void)
{

#if 1    
    short sh = 0;
    unsigned short s1 = 0, s2 = 0;

    if(sHermes)
    {
	char *q, *p1 = strchr(ComDev, 'b');
	s1 = strtoul(p1+1, &q, 10);
	if(*q == '.')
	{
	    p1 = q+1;
	    if((s2 = strtoul(p1, &q, 10)))
	    {
		sh = q-p1-1;
	    }
	}
	if(*q == 'k')
	{
	    if(s2)
	    {
		short i;
		for(i = 0; i < 3-sh; i++)
		{
		    s2 *= 10;
		}
	    }
	    wBaud = s1*1000 + s2;
	}
	else
	{
	    wBaud = s1;
	}
    }

    if(s1 == 0)
    {
	wBaud = stSpeed[Setups[SET_BAUD].current].value;
    }
#else
    wBaud = stSpeed[Setups[SET_BAUD].current].value;
#endif

    if(wBaud && wBaud != 0xffff)
    {
	wBaud = SplitBaud(wBaud);
	if(s1 == 0) mt_baud(wBaud);
	pS->Wait = 1 + (4800 / wBaud);
    }
    else
    {
	pS->Wait = 1;
    }
    if (QT.Swait)
    {
	pS->Wait = QT.Swait;
    }
}

SetParams (int flag)
{
    int i;
    UCHAR xLoc, nSer, nLoc;
    short emu = 0;
    
    wBaud = stSpeed[Setups[SET_BAUD].current].value;

    nSer = nLoc = 0;

    for (i = SET_EMUL; i < SET_END; i++)
    {
	if (flag == 0 || flag == Setups[i].Change)
	{
	    Setups[i].Change = FALSE;
	    switch (i)
	    {
		case SET_EMUL:
                    emu = 1;
		    break;
		    
		case SET_PARI:
                    pS->QCIS = stParity[Setups[SET_PARI].current].value;
                    break;
                    
        	case SET_PORT:
		case SET_FLOW:
		case SET_PROT:
		case SET_CODEV:
		    nSer = 1;
		    break;
		case SET_BAUD:
		    SetBaudRate();
		    break;
		case SET_RX_EOL:
		    bRXEOL = stCRLF[Setups[SET_RX_EOL].current].value;
		    break;
		case SET_TX_EOL:
		    bTXEOL = stCRLF[Setups[SET_TX_EOL].current].value;
		    break;
		case SET_WRAP:
		    bWrap = stWrap[Setups[SET_WRAP].current].value;
		    break;
		case SET_JSW:
		    (short) *((short *) ((char *) (_sys_var + 0x92))) =
			(USHORT) stSwap[Setups[SET_JSW].current].value;
		    break;
		case SET_XON:
		    pS->bFlow = stYesNo[Setups[SET_XON].current].value;
		    break;
		case SET_CTRL:
		    bCtrl = stCtrl[Setups[SET_CTRL].current].value;
		    break;
		case SET_EXBD:
		    ExBaud = stExSpeed [Setups[SET_EXBD].current].value;
		    if(ExBaud && ExBaud != 0xffff)
		    {
			ExBaud = SplitBaud(ExBaud);
		    }
		    break;
		case SET_DELC:
		    bDelChar = stDelC[Setups[SET_DELC].current].value;
		    break;
		case SET_BEEP:
		    bBeep = stWrap[Setups[SET_BEEP].current].value;
		    break;
		case SET_CSI:
		    bShowCSI = stCtrl[Setups[SET_CSI].current].value;
		    break;
		case SET_CDEL:
		    CDelay = ASCIIParam (CmdDel, 0, 32767, 0);
                    break;
		case SET_MODE:
		    nLoc = 1;
		    break;
		case SET_DTRY:
		    qC->dTry = ASCIIParam (DtxtTry, 0, 12, 0);
		    break;
		case SET_DWAIT:
		    qC->dWait = ASCIIParam (DtxtWait, 20, 300, 60);
		    break;
		case SET_SCROLL:
		    jScroll = ASCIIParam (TScroll, 0, 24, 0);
		    break;
		case SET_OLINER:
		    okey =  ASCIIParam (OBuffer, 0, 255, 0);
		    break;
		case SET_ZQUIET:
		    zquiet =  ASCIIParam (ZBuffer, 0, 32676, 250);
		    break;
		case SET_PROTO:
		    if (stackser == 0 && stricmp (MyProtocol, xproto))
		    {
			XPRStatus = XPRUse (MyProtocol);
			strcpy (xproto, MyProtocol);
		    }
		    break;
		case SET_KEY0:
                    wwFlag = 0xff00 | stArrows[Setups[SET_KEY0].current].value;
		    break;
                case SET_KEY1:
                    key7 = stYesNo[Setups[SET_KEY1].current].value;
                    break;
		case SET_XICON:
		    xicon = stXPR[Setups[SET_XICON].current].value;
		    break;
		case SET_VTPAD:
		    bVTPad = stYesNo[Setups[SET_VTPAD].current].value;
		    break;
		case SET_REDRAW:
		    bWakeDraw = stRedraw[Setups[SET_REDRAW].current].value;
		    break;
		case SET_SAVECR:
		    saveCR = stYesNo[Setups[SET_SAVECR].current].value;
		    break;
	    }
	}
    }

    if(stackser)
    {
	stackser = 0;
	xLoc = bLocal = 3;
	pSerial = "UserChans";
	*xproto = *MyProtocol = *ComDev = '\0';
	nLoc = 0;
    }
    else
    {
	if(nLoc)
	{
	    xLoc = bLocal;
	    bLocal = stMode[Setups[SET_MODE].current].value;
	    if (bLocal != xLoc)
	    {
		if (bLocal == 1)
		{
		    CloseSerial();
		    pS->pSerId = io_open ("pipe_256", 0);
		    pDummy = io_open ("pipe_0", pS->pSerId);
		    if(nSer)
		    {
			SetSerial(0);
			nSer = 0;
		    }
		}
		else if (pDummy > 0 && xLoc == 1)
		{
		    io_close (pDummy);
		    pDummy = 0;
		    SetSerial (1);
		    nSer = 0;
		    if (pS->Pid)
		    {
			mt_reljb (pS->Pid);
			mt_prior (pS->Pid, QT.Sprio);
		    }
		}
	    }
	}
    
	if(nSer)
	{
	    SetSerial((bLocal != 1));
	}
    }
    
    if(emu)
    {
	bEmulation = stVt[Setups[SET_EMUL].current].value;
#ifdef  VDATA
        bMaxChar = (bEmulation == VIEWD) ? 40 : 80;
#else
	bMaxChar = scrX;
#endif
	VT100Init (0);
	if (bEmulation & ANSI_M)
	{
	    ANSIFont (pChId);
	}
#ifdef VDATA
        else if (bEmulation == VIEWD)
        {
            extern void ViewFont(int);
            ViewFont(pChId);
        }
#endif
	else
	{
	    QLFont (pChId);
	}
    }
}
int ASCIIParam (char *txt, int vmin, int vmax, int vdef)
{
    int rval;
    char *p;
    char *fmt;

    rval = strtol (txt, &p, 0);
    if (*p | ' ' == 'k')
    {
	rval = rval << 10;
    }
    if (rval < vmin || rval > vmax)
    {
	rval = vdef;
	OutError ("%s Parameter Error, using default", txt);
    }
    if((*txt == 0) && (*(txt+1) | 32 == 'x'))
	fmt = "%x";
    else
	fmt = "%d";

    sprintf (txt, fmt, rval);
    return rval;
}

QCInit ()
{
    SetParams (1);
    if (*ModemIni)
    {
	ParseString (ModemIni, (int (*)(char, char **))pS->SendChr, 1, NULL);
	mt_susjb (-1, 25, NULL);
    }
}



void SetSerial (int flag)
{
    char *pDef;
    static char pName[16] = "ser";
    
    if (*ComDev && *ComDev != '+' && *ComDev != '#')
    {
	pSerial = ComDev;
    }
    else
    {
	pSerial = pName;
	pDef = (pName + 3);
	*pDef++ = stPort[Setups[SET_PORT].current].value;
	if(*ComDev == '+')
	{
	    pDef = stpcpy(pDef, ComDev + 1);
	}
	*pDef++ = stShake[Setups[SET_FLOW].current].value;
	*pDef++ = stProt[Setups[SET_PROT].current].value;
	*pDef = '\0';
    }
    
    SetBaudRate();

    if(flag)
    {
        CloseSerial();
        pS->pSerId = io_open (pSerial, IO_NEW);
/*        Report(("Serial %x\n", pS->pSerId));*/
        
        if (pS->pSerId < 0)
        {
	    QErr (pSerial, pS->pSerId);
	    beep (20000, 10);
        }
        pS->SerSts = 0;
        if(pS->Pid)
        {
            mt_reljb (pS->Pid);
        }
    }
}
