/*
 * $Log: qedit.c,v $
 * Revision 1.2  1997/08/23 21:13:39  jrh
 * pre config removal
 *
 * Revision 1.1  1995/09/16 17:22:18  root
 * Initial login under Linux
 *
 * Revision 1.5  1995/03/27  21:57:58  jrh
 * Fix Blank menus (please...)
 *
 * Revision 1.4  1995/03/24  16:29:31  jrh
 * Menu code & XPrefs crash
 *
 * Revision 1.3  1995/03/12  23:00:08  jrh
 * scripting
 *
 * Revision 1.2  1994/05/31  22:19:55  jrh
 * c68 v41.3c fixes
 *
 * Revision 1.1  1994/05/30  21:43:18  jrh
 * Initial checkin at v1.33
 *
 */

static char rcsid[] ="$Id: qedit.c,v 1.2 1997/08/23 21:13:39 jrh Exp $";

#include <stdio.h>
#include <qdos.h>
#include <qlib.h>
#include <qptr.h>

#include <pd/xproto.h>
#include "xprmisc.h"

#include "defs.h"

#define NO_OPEN     1
#define NO_SAVE     2
#define NO_SAVEAS   4
#define NO_DEFAULT  8
#define NO_MINIT    0x10
#define CFLAG       38

Prototype EditFiles (struct WM_wwork *);
Prototype EditModem (struct WM_wwork *);
Prototype EditSetup (struct WM_wwork *);
Prototype EditDial (struct WM_wwork *, PEDITLIST);

Local struct QD_text *MakeDesc (char *);
Prototype XPROptions (struct WM_wwork *, struct xpr_option *, int);

static QD_TEXTI (A_OK, "OK");
static QD_TEXTI (ESCAPE, "Quit");
static QD_TEXTI (COMMAND, "Commands F3");
static QD_TEXTI (ABORT, "Abort");

static int MABORT (struct WM_wwork *, struct WM_litm *);
static int MESC (struct WM_wwork *, struct WM_litm *);
static int MCOMMAND (struct WM_wwork *, struct WM_litm *);

static struct WM_action mesc = {JSR, wm_actli, MESC};
static struct WM_action mabort = {JSR, wm_actli, MABORT};
static struct WM_action mcommand = {JSR, wm_actli, MCOMMAND};

static struct WM_litm lsetup[] =
{
    {72, 10,
     140, 2,
     0, 0,
     TYP_TEXT, 0xf0,
     &COMMAND,
     0,
     &mcommand},

    {42, 10,
     240, 2,
     0, 0,
     TYP_TEXT, 0xfd,
     &ABORT,
     1,
     &mabort},

    {30, 10,
     348, 2,
     0, 0,
     TYP_TEXT, K_CANCEL,
     &ESCAPE,
     2,
     &mesc},
    {-1, -1}
};

static struct WM_litm ldial[] =
{
    {42, 10,
     240, 2,
     0, 0,
     TYP_TEXT, 128,
     &ABORT,
     0,
     &mabort},

    {30, 10,
     348, 2,
     0, 0,
     TYP_TEXT, K_CANCEL,
     &ESCAPE,
     1,
     &mesc},
    {-1, -1}
};

static struct WM_litm lqc[] =
{
    {30, 10,
     154, 2,
     0, 0,
     TYP_TEXT, K_CANCEL,
     &A_OK,
     0,
     &mesc},
    {-1, -1}
};

static int pflag = 0;

static int MESC (struct WM_wwork *wwk, struct WM_litm *li)
{
    return PT__CAN;
}
static int MCOMMAND (struct WM_wwork *wwk, struct WM_litm *li)
{
    int n = 0;

    n = PrefsComMenu (wwk, pflag);
    if (n)  
    {
	n = PT__WSIZ;
    }

    wwk->wstat->litem[li->item] = WSI_MKAV;
    wm_ldraw (wwk, -1);
    wwk->wstat->litem[li->item] = WSI_AVBL;

    return n;
}
static int MABORT (struct WM_wwork *wwk, struct WM_litm *li)
{
    wwk->wstat->litem[CFLAG] = 0;
    return PT__CAN;
}

EditSetup (struct WM_wwork * wwk)
{
    static QD_TEXTI (qt, "Preferences");
    int n;

    pflag = 0;
    mt_susjb (ClkPID, -1, NULL);
    n = EditPrefs (wwk, (struct QD_text *) &qt, Setups, lsetup, NULL);
    mt_reljb (ClkPID);
    if(n)
    {
        bConf = 1;
    }
    return n;
}
EditDial (struct WM_wwork * wwk, PEDITLIST pEd)
{
    static QD_TEXTI (qt, "Phone Options");
    int n;

    pflag = 0;
    n = EditPrefs (wwk, (struct QD_text *) &qt, pEd, ldial, NULL);
    return n;
}

static struct QD_text *MakeDesc (char *p)
{
    int j;
    struct QD_text *qd;

    j = strlen (p);

    qd = (struct QD_text *) xmalloc (j + 4);

    qd->len = j;
    strcpy ((char *) qd->chrs, p);
    return qd;
}

int XPROptions (struct WM_wwork *wwk, struct xpr_option *Opts, int n)
{
    PEDITLIST pEd, pL;
    struct QD_text *pTitle;
    struct xpr_option *pO;
    int i, j;
    int no;
    int nt = -1;
    char *p;
    int rval = 1;

    for (pO = Opts, i = 0; i < n; i++, pO++)
    {
	if (pO->xpro_type == XPRO_HEADER)
	{
	    nt = i;
	    break;
	}
    }

    pEd = (PEDITLIST) xmalloc (((n + 2) * sizeof (EDITLIST)));

    if (nt != -1)
    {
	p = (Opts + nt)->xpro_description;
    }
    else
    {
	p = "XPR Options";
    }

    pTitle = MakeDesc (p);

    no = 0;
    pO = Opts;
    pL = pEd;

    for (i = 0; i < n; i++)
    {
	if (pO->xpro_type != XPRO_HEADER)
	{
	    switch (pO->xpro_type)
	    {
		case XPRO_BOOLEAN:
		    pL->Title = MakeDesc (pO->xpro_description);
		    pL->list = stYesNo;	/* this is yes/no */
		    pL->type = TOGGLE;
		    pL->current = (*pO->xpro_value == 'Y' ||
				   *pO->xpro_value == 'y') ? 0 : 1;
		    pL->defval = i;
		    break;
		case XPRO_LONG:
		case XPRO_STRING:
		case XPRO_COMMPAR:
		    pL->Title = MakeDesc (pO->xpro_description);
		    pL->list = pO->xpro_value;
		    pL->type = (pO->xpro_type == XPRO_COMMPAR) ? XCPAR : EDIT;
		    pL->defval = (pO->xpro_length > 24) ? 24 : pO->xpro_length;
		    pL->current = i;
		    break;
		case XPRO_COMMAND:
		    pL->Title = MakeDesc (" ");
		    pL->list = MakeDesc (pO->xpro_description);
		    pL->type = XPCMD;
		    pL->current = i;
		    break;
	    }
	    pL->xp = 0;
	    pL->yp = no++;
	    pL++;
	}
	pO++;
    }

    pL->Title = NULL;
    pL->list = NULL;

    EditPrefs (wwk, pTitle, pEd, ldial, &rval);

    for (pL = pEd; pL->Title; pL++)
    {
	xfree (pL->Title);
	if (pL->type == XPCMD)
	{
	    xfree (pL->list);
	}
	if (pL->type == TOGGLE)
	{
	    if (pL->current == 0)
	    {
		strcpy ((Opts + pL->defval)->xpro_value, "yes");
	    }
	    else
	    {
		strcpy ((Opts + pL->defval)->xpro_value, "no");
	    }
	}

    }
    xfree (pEd);
    xfree (pTitle);
    return rval;
}
EditModem (struct WM_wwork * wwk)
{
    static QD_TEXTI (qt, "Modem Commands");
    int n;
    int dummy;

    pflag = NO_DEFAULT;
    n = EditPrefs (wwk, (struct QD_text *) &qt, ModemSetups, lsetup, &dummy);
    if(n)
    {
        bConf = 1;
    }
    return n;
}
EditFiles (struct WM_wwork * wwk)
{
    static QD_TEXTI (qt, "File Preferences");
    int n;
    int dummy;

    pflag = (NO_DEFAULT | NO_MINIT);
    n = EditPrefs (wwk, (struct QD_text *) &qt, FileSetups, lsetup, &dummy);
    if(n)
    {
        bConf = 1;
    }
    return n;
}
