/*
 * $Log: qtp.c,v $
 * Revision 1.16  1998/06/12 20:03:01  jrh
 * Fixed -i bug
 *
 * Revision 1.15  1998/02/25 23:13:32  jrh
 * Fixed for programatic resize
 *
 * Revision 1.14  1998/01/18 18:54:20  jrh
 * for 1.63 release
 *
 * Revision 1.13  1997/08/23 21:11:08  jrh
 * pre config removal
 *
 * Revision 1.12  1997/04/13 16:54:18  jrh
 * cursor and console changes
 *
 * Revision 1.11  1996/12/25 12:55:47  jrh
 * Allowed -d for SMSQE baud options
 *
 * Revision 1.10  1996/12/23 22:32:58  jrh
 * Checkin for 1.62
 *
 * Revision 1.9  1996/07/10  19:06:11  jrh
 * Fix for menu_rext
 *
 * Revision 1.8  1996/07/10  12:16:04  jrh
 * Move and redraw
 *
 * Revision 1.7  1996/07/09  12:25:57  jrh
 * post fsel (1.60)
 *
 * Revision 1.6  1996/07/09  09:26:14  jrh
 * pre file sel (1.599)
 *
 * Revision 1.5  1996/01/19  13:23:56  root
 * Revised for 1.57
 *
 * Revision 1.4  1995/12/30  18:28:09  root
 * For v1.57 (QXL baud, SH status, CSM crash)
 *
 * Revision 1.3  1995/11/26  14:29:04  root
 * System specific changes
 *
 * Revision 1.2  1995/11/12  15:29:37  root
 * Baud rates for QXL etc
 *
 * Revision 1.1  1995/09/16  17:22:18  root
 * Initial login under Linux
 *
 * Revision 1.16  1995/05/13  11:24:14  jrh
 * Final 1.53 revision
 *
 * Revision 1.15  1995/03/31  21:21:23  jrh
 * Add User menu code and icon
 *
 * Revision 1.14  1995/03/31  12:21:52  jrh
 * Fix mallocs to use xmalloc
 *
 * Revision 1.13  1995/03/28  18:30:06  jrh
 * Correct return of DIAL results
 *
 * Revision 1.12  1995/03/13  22:13:34  jrh
 * Added init/exit scripting
 *
 * Revision 1.11  1995/03/12  23:00:08  jrh
 * scripting
 *
 * Revision 1.10  1995/02/12  18:10:24  jrh
 * scripting beta
 *
 * Revision 1.9  1995/02/07  16:52:32  jrh
 * Changes for v3.3 XPR and wildcarding
 *
 * Revision 1.8  1994/12/22  17:55:07  jrh
 * Sort out local & graphics at EOL
 *
 * Revision 1.7  1994/12/15  21:31:12  jrh
 * 80 col changes
 *
 * Revision 1.6  1994/07/27  11:33:00  jrh
 * Revised to v1.36 (nothing done ?)
 *
 * Revision 1.5  1994/07/09  15:34:29  jrh
 * Changes for VT100 and button frame
 *
 * Revision 1.4  1994/06/09  16:22:27  jrh
 * Add generic text messages
 *
 * Revision 1.3  1994/06/05  19:10:16  jrh
 * VT100/VT102 options and clock fix
 *
 * Revision 1.2  1994/05/31  22:19:55  jrh
 * c68 v4.13c & new connect logic
 *
 * Revision 1.1  1994/05/30  21:43:06  jrh
 * Initial checkin at v1.33
 *
 */

static char rcsid[] ="$Id: qtp.c,v 1.16 1998/06/12 20:03:01 jrh Exp jrh $";

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>
#include <qdos.h>
#include <qptr.h>
#include <qlib.h>
#include <stdarg.h>
#ifdef SIGS
#include <signal.h>
#include <sys/signal.h>
#endif

#define  MAIN_MODULE   1
#define CURSOR 1

#include "defs.h"
#include "srv.h"

#if 0
long (*_stackchannels) (long) = NULL;
#endif

long (*_cmdchannels) (long) = NULL;
long (*_conread) () = NULL;
long (*_conwrite) () = NULL;
void (*_consetup) (chanid_t, struct WINDOWDEF *) = NULL;
char *_endmsg = NULL;
char _prog_name [] = "QTPI";

long _stack = 6144;

extern struct WM_sprite mes_files, mes_modem, mes_prefs, mes_dial, mes_cursor,
 mes_xfer, mes_watch, mes_paw, mes_null, mes_move, mes_slee, mes_menu,
 mono_files, mono_modem, mono_prefs, mono_phone, mono_xfer,mes_size;

#define MES_CURSOR mes_cursor

char * wm_vectr;
long QPTR_VERS = 0;

Prototype DoStatus (void);
Prototype OutError (char *,...);

Prototype QErr (char *, int);

Prototype void PosText(void);
Prototype void PosNull(void);

Prototype void *xmalloc( int);
Prototype void MakePoint(void);

Local int ResetDialler (struct WM_wwork *);
Local long AMOVE (struct WM_wwork *);
static StartDialJob (struct WM_wwork *);
Local ProcessDial (struct WM_wwork *);

extern long ASLEEP (struct WM_wwork *wwk);
extern long ADUMMY (struct WM_wwork *wwk);
static long AHIT (struct WM_wwork *wwk, struct WM_appw *apw, 
		  struct WM_wstat *wst, short x, short y, short evnt);
static long ADRAW (struct WM_wwork *wwk, struct WM_appw *apw);
static long AICON (struct WM_wwork *wwk, struct WM_litm *li);
static long ASUB (struct WM_wwork *wwk, struct WM_litm *li);

static struct WM_action asleep = {JSR, wm_actli, ASLEEP};
static struct WM_action adummy = {JSR, wm_actli, ADUMMY};
static struct WM_action amove = {JSR, wm_actli, AMOVE};
static struct WM_action IconMenu = {JSR, wm_actli, AICON};
static struct WM_action asub = {JSR, wm_actli, ASUB};
static struct WM_action adraw = {JSR, wm_drwaw, ADRAW};
static struct WM_action ahit = {JSR, wm_hitaw, AHIT};
static struct WM_action afun = {JSR, wm_actli, lit_event};

struct WM_sprite *mes_point;
static short abell = 0;
static struct QLRECT rct;

char * __SigNoMsg = 0;

#define ninfw    1		/* number of information windows */
#define ninfo    0		/* number of information objects */
#define nlitm    13		/* number of loose items */
#define nappl    4		/* number of application sub-windows */

static AST ast0 = {0}, ast1 = {0}, ast2 = {0}, ast3 = {0};

static struct WM_wstat ws =	/* window status area */
{
    NULL,			/* *wwork point back to work def */
    NULL,			/* *wdef this was wdef */
    0,				/* chid chan ID enclosing pointer */
    0, 0, 0,			/* swnr, xpos, ypos sub-window and ptr posn */
    0, 0,			/* kstk, kprs key stroke and press */
    0,				/* evnt event vector */
    0, 0, 0, 0,			/* xsiz, ysiz, xorg, yorg  */
    0, 0,			/* ptpsx, ptpsy pointer position (abs) */
    FORM_QL4, 0, 0,		/* wmode, 2 spare window mode and spare */
    NULL,			/* *ciact current item "action" */
    -1,				/* citem  current item */
    0, 0, 0,			/* cibrw, cipap, cispr  current item attr */
    0, 0, 0, 0,			/* cihxs,ys, cihxo,yo   current item hit area */
    {0, 0, 0, 0, 0, 0, 0, 0}	/* litem[40] loose item status */
};


static QD_TEXTI (END, "BYE");
static QD_TEXTI (SPT, "Run");
static QD_TEXTI (WATCH,"<*>");

static struct WM_infw infw[ninfw + 1] =	/* information window */
{
    {24, 188,			/* xsize, ysize size */
     0, 2,			/* xorg, yorg and origin */
     0,				/* flag no clear + shadow */
     0, 7, 0,			/* borw, borc, papr border width/clr,paper */
     NULL},			/* *pobj pointer to object list */
    {-1}			/* end of array */
};

static struct WM_litm litm[nlitm + 1] =	/* loose item */
{
    {18, 10, 2,   1, 0, 0, 2, K_MOVE,  &mes_move,  LIT_MOVE,  &amove},
    {18, 10, 2,  13, 0, 0, 2, K_SIZE,  &mes_size,  LIT_SIZE,  &afun},
    {18, 10, 2,  25, 0, 0, 2, K_SLEEP, &mes_slee,  LIT_SLEEP, &asleep},
    {18, 16, 2,  37, 0, 0, 2, SF1,     &mes_files, LIT_FILES, &IconMenu},
    {18, 10, 3,  55, 0, 0, 2, SF2,     &mes_modem, LIT_MODEM, &IconMenu},
    {18, 16, 3,  67, 0, 0, 2, SF3,     &mes_prefs, LIT_PREFS, &IconMenu},
    {18, 16, 3,  85, 0, 0, 2, SF4,     &mes_dial,  LIT_DIAL,  &IconMenu},
    {18, 17, 2, 103, 0, 0, 2, SF5,     &mes_xfer,  LIT_XFER,  &IconMenu},
    {16, 13, 5, 122, 0, 0, 2, 0xeb,    &mes_paw,   LIT_HANDY, &IconMenu},
    {18, 12, 2, 137, 0, 0, 2, 0xf3,    &mes_menu,  LIT_SCRIPT,&IconMenu},
    {18, 12, 2, 151, 0, 0, 0, 254,     &END,       LIT_QUIT,  &IconMenu},
    {18, 20, 2, 165, 0, 0, 2, 0xef,    &mes_null,  LIT_WATCH, &asub},
    {2,  2,  2,   1, 0, 0, 2, K_HELP,  &mes_null,  LIT_HELP,  &adummy},
    {-1}
};

static struct WM_appw aw0 =	/* application sub-window */
{
    484,240,			/* xsize, ysize         size */
    24, 1, 			/* xorg, yorg           and origin */
    0x0100,			/* flag                 no clear + shadow */
    1, 7, 0,			/* borw, borc, papr border width/clr, paper */
    NULL,			/* *pspr                pointer to sprite */
    &adraw,			/* *draw                draw routine */
    &ahit,			/* *hit                 hit routine */
    NULL,			/* *ctrl                control routine */
    0, 0,			/* nxsc, nysc           max x,y sections */
    0, 0, 0,			/* skey, 2 spare        selection keystroke */
    NULL,			/* *pwcb            part window ctrl block */
    0, 0, 0, 0, 0, 0, NULL, NULL,	/* 6 short 2 pointer zero */
    CL_WRROW, CL_WBARB, CL_WBARS,	/* psac, psbc, pssc arrow/bar clrs */
    NULL,			/* *pwcb    part window ctrl block */
    0, 0, 0, 0, 0, 0, NULL, NULL,	/* 6 short 2 pointer zero */
    CL_WRROW, CL_WBARB, CL_WBARS,	/* psac, psbc, pssc arrow/bar clrs */
    &ast0
};

static struct WM_appw aw1 =	/* application sub-window */
{
    400, 12,			/* xsize, ysize         size */
    0, 242,			/* xorg, yorg     and origin */
    0,				/* flag                 no clear + shadow */
    0, 7, 3,			/* borw, borc, papr     border width/clr,paper */
    NULL,			/* *pspr                pointer to sprite */
    &adraw,			/* *draw                draw routine */
    NULL,			/* *hit                 hit routine */
    NULL,			/* *ctrl                control routine */
    0, 0,			/* nxsc, nysc           max x,y sections */
    0, 0, 0,			/* skey, 2 spare        selection keystroke */
    NULL,			/* *pwcb            part window ctrl block */
    0, 0, 0, 0, 0, 0, NULL, NULL,	/* 6 short 2 pointer zero */
    CL_WRROW, CL_WBARB, CL_WBARS,	/* psac, psbc, pssc arrow/bar clrs */
    NULL,			/* *pwcb            part window ctrl block */
    0, 0, 0, 0, 0, 0, NULL, NULL,	/* 6 short 2 pointer zero */
    CL_WRROW, CL_WBARB, CL_WBARS,	/* psac, psbc, pssc arrow/bar clrs */
    &ast1
};

static struct WM_appw aw2 =	/* application sub-window */
{
    102, 12,			/* xsize, ysize         size */
    404, 242,			/* xorg, yorg           and origin */
    0,				/* flag                 no clear + shadow */
    0, 7, 0,			/* borw, borc, papr     border width/clr, paper */
    NULL,			/* *pspr                pointer to sprite */
    &adraw,			/* *draw                draw routine */
    NULL,			/* *hit                 hit routine */
    NULL,			/* *ctrl                control routine */
    0, 0,			/* nxsc, nysc           max x,y sections */
    0, 0, 0,			/* skey, 2 spare        selection keystroke */
    NULL,			/* *pwcb            part window ctrl block */
    0, 0, 0, 0, 0, 0, NULL, NULL,	/* 6 short 2 pointer zero */
    CL_WRROW, CL_WBARB, CL_WBARS,	/* psac, psbc, pssc arrow/bar clrs */
    NULL,			/* *pwcb            part window ctrl block */
    0, 0, 0, 0, 0, 0, NULL, NULL,	/* 6 short 2 pointer zero */
    CL_WRROW, CL_WBARB, CL_WBARS,	/* psac, psbc, pssc arrow/bar clrs */
    &ast2
};
static struct WM_appw aw3 =	/* application sub-window */
{
    22,20,			/* xsize, ysize size */
    0, 188,			/* xorg, yorg and origin */
    NO_WCLEAR,			/* flag no clear + shadow */
    0, 0, 0,			/* borw, borc, papr border width/clr, paper */
    NULL,			/* *pspr                pointer to sprite */
    NULL,			/* *draw                draw routine */
    NULL,			/* *hit                 hit routine */
    NULL,			/* *ctrl                control routine */
    0, 0,			/* nxsc, nysc           max x,y sections */
    0, 0, 0,			/* skey, 2 spare        selection keystroke */
    NULL,			/* *pwcb            part window ctrl block */
    0, 0, 0, 0, 0, 0, NULL, NULL,	/* 6 short 2 pointer zero */
    CL_WRROW, CL_WBARB, CL_WBARS,	/* psac, psbc, pssc arrow/bar clrs */
    NULL,			/* *pwcb part window ctrl block */
    0, 0, 0, 0, 0, 0, NULL, NULL,	/* 6 short 2 pointer zero */
    CL_WRROW, CL_WBARB, CL_WBARS,	/* psac, psbc, pssc arrow/bar clrs */
    &ast3
};

static struct WM_appl appl[nappl + 1] =
{
    &aw3, &aw2, &aw1, &aw0, NULL
};

static WM_WSCALE (ninfw + ninfo + nlitm + nappl) wsc =
{
   /* x    y   X    Y   x+  y+ */
     460, 224, 508, 254, 12, 10, 
     {
	{0, 0, 0, 0},			/* infw[0], no scale */
	{0, 0, 0, 0},			/* litm[0], no scale */
	{0, 0, 0, 0},			/* litm[1], no scale */
	{0, 0, 0, 0},			/* litm[2], no scale */
	{0, 0, 0, 0},			/* litm[3], no scale */
	{0, 0, 0, 0},			/* litm[4], no scale */
	{0, 0, 0, 0},			/* litm[5], no scale */
	{0, 0, 0, 0},			/* litm[6], no scale */
	{0, 0, 0, 0},			/* litm[7], no scale */
	{0, 0, 0, 0},			/* litm[8], no scale */
	{0, 0, 0, 0},			/* litm[9], no scale */
	{0, 0, 0, 0},			/* litm[10], no scale */
	{0, 0, 0, 0},			/* litm[11], no scale */
	{0, 0, 0, 0},			/* litm[12], no scale */
	{0, 0, 0, 0},			/* appw[3], no scale */
	{0, 0, 8, 8},			/* appw[2], y pos */
	{8, 0, 0, 8},			/* appw[1], y pos */
	{8, 8, 0, 0}			/* appw[0], x,y size */
    }
};

static struct WM_wwork ww =	/* window working definition */
{
    &ws,			/* *wstat pointer to status area */
    (WM_wscale_t *) & wsc,	/* *wscale this was pointer to WDEF */  
    0,				/* chid channel ID */
    NULL,			/* *pprec pointer to pointer record */
    0,				/* psave  pointer position saved */
    0, 0, 0, 0,			/* 4 zero */
    appl,			/* *splst pointer to sprite list */
    508, 254,			/* xsize, ysize size */
    2, 1,			/* xorg, yorg and origin */
    0,				/* flag no clear + shadow */
    1, 7, 0,			/* borw, borc, papr border width/clr, paper */
    NULL,			/* *sprite pointer to sprite */
    1, 7,			/* curw, curc current item width/clr */
    3, 7, NULL, NULL,		/* uback, uink, *ublob, *upatt  unavail */
    0, 7, NULL, NULL,		/* aback, aink, *ablob, *apatt  avail */
    4, 0, NULL, NULL,		/* sback, sink, *sblob, *spatt  selected */
    NULL,			/* *help */
    ninfw, ninfo, infw,		/* ninfo, ninob, *pinfo info winds */
    nlitm, litm,		/* nlitm, *plitm loose items */
    nappl-1, appl		/* nappl  *pappl appl winds */
};


struct WM_wwork *Main_ww = &ww;
short SrvCmd = 0;

char QeM_Dat[64] = {"flp1_QTPI_dat"};

char mono = 0;
char hflag = 1;
unsigned short dbflag = 0;
short scrX = 0;
short scrY = 24;
short maxser = 2;
short useFS = 1;
short conf1 = 0;
short conf2 = 0;

static short st_ink = 7;
extern int BuildSMenu (void);
extern UserAction(WM_wwork_t *wwk);
long re_size (struct WM_wwork *, short, short);
static long do_size (struct WM_wwork *);
extern unsigned short CYsize;
char mvwin[2] = {0};
static void newsize (WM_wwork_t *wwk);
short iconic = 0;

void XAction(struct WM_wwork *pwk)
{	    
    AutoXPR (pwk, DO_XPR);
    DO_XPR = 0;
    if(Blocked)
    {
	Blocked = 0;
	mt_reljb (SerJID);
    }
}

void static SetIconMode(WM_wwork_t *pwk)
{	    
    menu_button (pwk, "QTPI", NULL);
    SrvCmd &= ~SRV_SLEEP;
    if(DO_XPR == 0 || xicon == 0)
    {
	PlayItAgainSam(0);
	DoStatus ();
	PosText();
    }
}

void CheckServerStuff(struct WM_wwork *pwk)
{
    if(SrvCmd & SRV_QUIT)
    {
	QShut(pwk, 1);
    }

    if(SrvCmd & SRV_UP)
    {
	ServerXPR(SRV_UP);
	SrvCmd &= ~SRV_UP;
    }

    if(SrvCmd & SRV_DN)
    {
	ServerXPR(SRV_DN);
	SrvCmd &= ~SRV_DN;
    }

    if(SrvCmd & SRV_AN)
    {
	if(!iconic)
	{
	    ServerASK (pwk, SRV_AN);
	}
	SrvCmd &= ~SRV_AN;
    }

    if(SrvCmd & SRV_AT)
    {
	if(!iconic)
	{
	    ServerASK (pwk, SRV_AT);
	}
	SrvCmd &= ~SRV_AT;
    }
    if( DoDialJob )
    {
	StartDialJob(pwk);
	SrvCmd &= ~SRV_DOZE;
    }
}
short zDelay = 0;
short stackser = 0;
short lx = -1,ly = -1;
char mvflg = 0;

void NewSize(char);

extern void FixBaud(void);
extern void re_scale (struct WM_wwork *, short *, short *);
extern short serstat;

#ifdef SIGS
static short showsig = 0;

void  SigNoImp(void)
{
    static char *msg[] = {
	"** WARNING **",
	" ",
	"Signal extension v0.30+ not loaded",
	"  ",
	"QTPI will work less well without sigext_rext",
	NULL
    };
    
    if(showsig && __SigNoCnt)
    {
	if(iconic)
	{
	    iconic = 0;
	    pick(pChId, -1, QTpid, K_WAKE);
	}
	AboutQTPI (&ww, 1, msg);
        __SigNoCnt = 0;
    }
}
#endif

int SaveContext (int chid, void **p, short *pcr)
{
    short mdef[4];
    int n;

    if((n = sd_pxenq(chid, -1, (QLRECT_t *)mdef)) == 0)
    {
	memcpy(pcr, mdef, sizeof(mdef));

	mdef[2] = mdef[3] = 0;
	n = iop_svpw(chid, -1, (WM_wsiz_t *) mdef, 0, 0, 
			     mdef[0], mdef[1], p);
    }
    return n;
}

int RestoreContext(int chid, void *p, short *pcr, short flag)
{
    short nx, mdef[4];
    int n;

    if((n = sd_pxenq(chid, -1, (QLRECT_t *) mdef)) == 0)
    {
	mdef[2] = mdef[3] = 0;

	if(pcr[2] > mdef[0])
	{
	    nx = pcr[0] - mdef[0];
	    pcr[2] = pcr[2] - nx;
	}
	else
	{
	    nx = 0;
	}
	if(mdef[0] > pcr[0]) mdef[0] = pcr[0];
	if(mdef[1] > pcr[1]) mdef[1] = pcr[1];

	n = iop_rspw(chid, -1, (WM_wsiz_t *) mdef, nx, 0, flag, p);
	if(pcr[3] > mdef[1])
	{
	    pcr[3] = mdef[1] - 6;
	}
	sd_pixp(chid, -1, pcr[2], pcr[3]);
    }
    return n;
}

static short dost = 0;

int main (int ac, char **av)
{
    time_t t1,t2;	
    static CLKBLK c = {0};
    struct WM_wwork *pwk=NULL;
    struct WM_wsiz wl;
    char *pt;
    ALIGN smsq = {"SMSQ"};
    ALIGN jsl1 = {"JSL1"};
    ALIGN sms2 = {"S2AT"};    
    ALIGN qdos = {"\xd2T\000\000"};

    if((pt = getenv("QTPI_OPT")))
    {
	char *q;
	typedef struct 
	{
	    char *opt;
	    short *val;
	} EVOPTS;

	EVOPTS *ev;
	static EVOPTS evopts[] = 
	{
	      {"flag=",(short *)&dbflag},
	      {"cols=",&scrX},
	      {"rows=",&scrY},
	      {"serl=",&maxser},
	      {"conf=",&conf1},
	      {"phon=",&conf2},
	      {NULL, 0}
	};

	strlwr(pt);

	mono  = strstr(pt, "mono") != NULL;
	hflag = strstr(pt, "slow") == NULL;
	useFS = strstr(pt, "nofs") == NULL;

	for(ev = evopts; ev->opt; ev++)
	{
	    if((q = strstr(pt, ev->opt)))
	    {
		*(ev->val) = strtol(q+5, NULL, 0);
	    }
	}
    }
    
    osid = 0xff;
    lStatus = 0; 

    pt = *((char **)(_sys_var + 0x7c));
    minnie = ((*((short *)(pt + 0x44)) == 4) &&
	      (*((long *)(pt + 0x46)) == jsl1.x));

    if(*((long *)(_sys_var)) == smsq.x)
    {
	specbaud =  *((char *)(_sys_var + 0xa7)) & 0x1f;
	osid = specbaud;
    }
    else if(*((long *)(_sys_var)) == sms2.x)
    {
	osid = 0xfe;
    }
    
    if(useFS)
    {
	extern int Test4Menus(void);
	useFS = Test4Menus();
    }
    
/*    FixBaud(); */
    
    DO_XPR = Blocked = 0;

    QTpid = getpid ();

    qC = &c;

    QeMInit (ac, av);
    FixBaud();

    if(dbflag & 0x60)
    {
	unsigned long *kptr, kval = 0;
	WM_sprite_t *s;
	short i;
	
	s = &MES_CURSOR;
	
	if(dbflag & 0x20) kval |= 0x00fc0000;
	if(dbflag & 0x40) kval |= 0xfc000000;

	kptr = (unsigned long *)((char *)&s->patt + s->patt);
	
	for(i = 0; i < s->ysize; i++)
	{
	    if((dbflag & 0x80) && (i < 7))
	    {
		*kptr++ = 0;
	    }
	    else
	    {
		*kptr++ = kval;
	    }
	}
    }

    if(mono)
    {
        litm[3].pobj = (char *) &mono_files;
        litm[4].pobj = (char *) &mono_modem;
        litm[5].pobj = (char *) &mono_prefs;
        litm[6].pobj = (char *) &mono_phone;
        litm[7].pobj = (char *) &mono_xfer;
        ww.sback = 7;
        aw1.papr = 7;
        st_ink = 0;
    }

    if(isatty(0))
    {
	ww.chid = getchid (0);
    }
    else
    {
	ww.chid = io_open ("con_512x256a0x0", 0);
	stackser = 1;
    }
    
    if((wm_vectr = iop_pinf(ww.chid, -1, &QPTR_VERS)) <= 0)
    {
        exit(-1);
    }

    ws.wwork = &ww;		/* set cross reference */

    ast2.chid = qC->pClId = io_open ("scr", 0);
    ast1.chid = pStId = io_open ("scr", 0);
    ast0.chid = pChId = io_open ("scr", 0);

    ws.litem[LIT_QUIT] = WSI_MKUN;

    iop_flim(ww.chid, -1, &wl);

    lx = (wl.xsize - ww.xsize)/2;
    ly = (wl.ysize - ww.ysize)/2;

    if(scrY != 24)
    {
	if(scrY > (wl.ysize-16)/10)
	{
	    scrY = (wl.ysize-16)/10;
        }	
	aw0.ysize = scrY * 10;
	aw1.yorg = aw2.yorg = aw0.ysize + 2;
	ww.ysize = aw0.ysize + 14;
    }
    
    ww.wscale->ymax = wl.ysize - 2;
    ww.wscale->xmax = wl.xsize - 4;

    if(ww.wscale->xmax > 820)
    {
	ww.wscale->xmax = 820;
    }

    if(scrX)
    {
	short dx, dy = 0;
	dx = scrX*6 - (aw0.xsize-4);
	re_scale(&ww, &dx, &dy);
    }

    scrX = aw0.xsize/6;
    
    sd_setin (pStId, -1, st_ink);
    sd_setst (pStId, -1, aw1.papr);
    sd_setpa (pStId, -1, aw1.papr);
    sd_setin (qC->pClId, -1, 7);

    mes_point = (struct WM_sprite *) ww.sprite;

    t1 = zDelay + time(NULL);

    if(!iconic)
    {
	QAwake = 1;
	wm_prpos (&ww, lx, ly);
	wm_wdraw (&ww);
	if(stackser == 0)
	{
	    pwk = (struct WM_wwork *) AboutQTPI (&ww, 0, NULL);
	}
	OutError ("Loading ...");
    }
    
    csr = 0;
    QTPI_Go();
    dost = 1;
    
    BuildSMenu ();
    GoOffLine();
    qC->qState = Q_IDLE;
    csr = 1;
	
    if(!iconic)
    {
	if(pwk)
	{
	    while((t2 = time(NULL)) < t1)
	    {
		mt_susjb(-1, 10, NULL);
	    }
	    wm_cluns (pwk);
	}
	DoStatus ();
        serstat = 2;        
    }
    else
    {
        serstat = 2;                
	SetIconMode (&ww);
    }
#ifdef SIGS
    showsig = 1;    
    if(raise (0))
    {
        SigNoImp();
    }
#endif
    if(!iconic)
    {
        pick(pChId, -1, QTpid, K_WAKE);
        PosText ();
    }

    while (1)
    {
        if(SrvCmd == 0)
        {
	    wm_rptr (&ww);
	}

	if (ws.evnt & PT_WSIZE)
	{
	    void *p;
	    int n;
	    short cdef[4];

	    if(mvwin[0])
	    {
		mvwin[0] = 0;
		n = SaveContext(pChId, &p, cdef); 
		newsize(&ww);
		if(n == 0)
		{
		    RestoreContext(pChId, p, cdef, 0);
		}
		DoStatus ();
	    }
	    else 
	    {
		if(do_size (&ww))
		{
		    DoStatus ();
		    MakePoint();
		    PosText();
		}
	    }
	    continue;
	}
	
	if (!iconic && (ws.evnt & PT_WAKE))
	{
	    QAwake = 2;
	}
	if ((ws.evnt & PT_ZZZZ) || (SrvCmd & SRV_SLEEP))
	{     
	    SetIconMode(&ww);
	}
	
	if (DO_XPR)
	{
	    XAction(&ww);
	}

	if(SrvCmd & ~SRV_SLEEP)
	{
	    CheckServerStuff(&ww);
	}
        if (abell && qC->dState == 0)
        {
	    ResetDialler (&ww);
            DoStatus ();
        }
        MakePoint();
        PosText();
    }
    return (0);
}

static long ADRAW (struct WM_wwork *wwk, struct WM_appw *apw)
{
    if(((PAST) apw->pstat)->chid > 0)
    {
        wm_swdef (wwk, apw, ((PAST) apw->pstat)->chid);
    }
    ws.litem[LIT_WATCH] = WSI_UNAV;
    ws.litem[LIT_QUIT] = WSI_AVBL;
    return 0;
}

static ProcessInput(int ch)
{
    if (ch)
    {
        ProcessKeys (ch);
	if ((pS->Count == 0 || bLocal) && csr)
	{
	    PosText ();
	}
        if (qC->qState == Q_WAIT)
        {
            qC->qState = Q_IDLE;
        }
    }
}    


static long AHIT (struct WM_wwork *wwk, struct WM_appw *apw, struct WM_wstat *wst,
		  short x, short y, short evnt)
{
    unsigned char ch;
    static char f1 = 0, kmov = 0;
    short kpos;
    extern char *_sys_vars;

    ch = 0;

    if(mvwin[0] & 1) 
    {
	mvwin[0] = 2;
	wst->evnt |= PT_WSIZE;
	return AHIT_NORMAL;
    }

    if(wwFlag)
    {
        if(wwFlag & 1)
        {
            aw0.flag |= 0x100;
        }
        else
        {
            aw0.flag &= ~0x100;
        }
        wwFlag = 0;
    }
#if 0
    {
	static cnt = 0;
	OutError("ev %04x wst->ev %04x (%02x %02x) ch %02x %d",
		 (unsigned short) evnt,
		 (unsigned short) wst->evnt,
		 (unsigned char) wst->kstk, (unsigned char) wst->kprs,
		 (unsigned char) *(short *)(_sys_var + 0x8a), cnt);
	cnt++;
    }
#endif
    kpos =  abs(wst->ptpsx - rct.q_x) + abs(wst->ptpsy - rct.q_y);

    if (evnt)
    {
        ch = (unsigned char) *(short *)(_sys_var + 0x8a);

        if(wst->evnt & PT_KYPRS)
        {
            if(evnt != ch)
            {
                if (evnt == K_HIT) ch = 0x20;
                if (evnt == K_DO)  ch = 0x0a;
		/* We'll treat these as WAKEs */
		if ((aw0.flag & 0x100)) /* Curse keys mode */
		{
		    wst->evnt |= PT_WAKE;
		    return AHIT_NORMAL;
		}
            }
        }
        else if(wst->evnt & PT_KYSTK)
        {
            ch = wst->kstk;
        }

	if((dbflag & 0x60) && (kpos > 10))
	{
	    if(ch == 0x20 ||  ch == 0x0a)
	    {
		PosText();
		return AHIT_NORMAL;	    
	    }
	}

        if ((aw0.flag & 0x100) == 0) /* move pointer mode */
        {
	    if (ch == 0xc0 || ch == 0xc8 || ch == 0xd0 || ch == 0xd8)
	    {
	        ch = 0;
	    }
	    else if (ch == 0xc4 || ch == 0xcc || ch == 0xd4 || ch == 0xdc)
	    {
	        ch -= 4;
	    }
	}
        ProcessInput(ch);
        kmov = 0;
    }
    else if ((wst->evnt & 0x1f) == PT_KEYUP)
    {
        kmov = 1;
        ch = (unsigned char) *(short *)(_sys_var + 0x8a);
        if(ch <  0x0a)
        {
            f1 ^= 1;
            if(f1 && ch)
            {
                ProcessInput(ch);
            }
        }
        else if(ch == 0xe8)
        {
            ProcessInput(0xe8);
        }
    }
    else if ((dbflag & 0x60) && (wst->evnt & PT_MOVE))
    {
        if(kpos && aw0.pspr == (char *) &MES_CURSOR)
        {
            kmov = 1;
            if(kpos > 10)
            {
                aw0.pspr = (char *) mes_point;
            }
	}
    }

    return AHIT_NORMAL;
}
void MakePoint(void)
{
    if(!(dbflag & 0x60))
    {
        short x = 10, y = 10;
        setptr(pChId, -1, &x, &y, -1);
    }
}

extern void ReviewBuffer(CAPDEF_t *);

static long AICON (struct WM_wwork *wwk, struct WM_litm *li)
{
    static int fopt = -1;
    int n;

    Blocked = 1;
    switch (li->item)
    {
	case LIT_FILES:
	    fopt = MenuFiles (wwk);
	    if (fopt == RECEIVE)
            {
                if ((XPRStatus & 2) == 2)
	        {
    	            XPRIO (BaseName, fopt);
		    fopt = -1;
	        }
                else
                {            
	            beep(2000,20);
                    OutError("F10 or Xfer Icon to Download");
		}
	    }
	    else if(fopt == 8 || fopt == 9)
	    {
		CAPDEF_t *c;

		if(fopt == 8)
		{
		    c = &Cap;
		}
		else
		{
		    c = &Xfr;
		}
		
                if(c->revid == 0)
                {
                    c->child = jcall(ReviewBuffer, c->name, 16, 4000, 1, c);
                }
                else
                {
                    if(pick (c->revid, -1, c->child, K_WAKE) != 0)
                    {
                        mt_frjob(c->child, 0);
                        c->child = c->revid = 0;
                    }
                }
	    }
            break;
	case LIT_MODEM:
	    MenuModem (wwk);
	    break;
	case LIT_PREFS:
	    MenuPrefs (wwk);
            DoStatus();
	    break;
	case LIT_DIAL:
	    MenuDial (wwk);
	    break;
	case LIT_XFER:
	    if (fopt == SEND || fopt == RECEIVE)
	    {
                if(fopt == SEND)
                {
                    XPRIO(NULL, fopt);
                }
                else
                {
    	            XPRIO (BaseName, fopt);
    	        }
		fopt = -1;
	    }
	    else
	    {
		menu_choice (wwk, "No Transfer Defined", 1, 0, "OK");
	    }
	    break;

	case LIT_HANDY:
	    MiscMenu (wwk);
	    break;

	case LIT_SCRIPT:
            UserAction(wwk);
	    break;

        case LIT_QUIT:
            QShut (wwk, 0);
            wwk->wstat->litem[li->item] = WSI_MKUN;
            wm_ldraw (wwk, -1);
            wwk->wstat->litem[li->item] = WSI_AVBL;
            break;
    }
    Blocked = 0;
    mt_reljb (SerJID);

    if (DoDialJob)
    {
	StartDialJob (wwk);
    }

    MakePoint();
    PosText();

    if(li->item != LIT_QUIT)
    {
        lit_reset (wwk, li->item);
    }
    return 0;
}
#if 0
LogMsg (char *ctl,...)
{
    static int fd = 0;
    va_list va;
    char t[80];

    va_start (va, ctl);

    vsprintf (t, ctl, va);
    va_end (va);
    if(fd == 0)
    {
        fd = io_open("ram1_qlog", 2);
    }
    io_sstrg (fd, -1, t, (short) strlen (t));
}
#endif
extern short okey,oflag;
DoStatus (void)
{
    static char txt[160];
    short nb;
    struct QD_text *pT;
    static char *lc[] =
    {
	"OnLine", "Local", "Echo", "piped"
    };
    static char eol[3] = {'l','c','R'};
    
    short lp = 0;

    if (QAwake && dost)
    {
	char connect[20];
	
	if(*ComDev && *ComDev != '+')
	{
	    sprintf(connect, "%-.15s", ComDev);
	}
	else
	{
	    sprintf(connect, "%d %-.10s", (wBaud & ~3), 
		    (pSerial) ? pSerial : "<none>");
	}
	if (bLocal > 3)
        {
            lp = 0;
        }
        else
        {
            lp = bLocal;
        }

        pT = (struct QD_text *) stVt[Setups[SET_EMUL].current].Text;
	sprintf (txt,
		 " QTPI %s %-.15s%c %s %s %s %s%s%s %c%c%c %c",
		 QTPI_VERS,
		 connect,
		 (pS->QCIS) ? pS->QCIS : ' ',
		 MyProtocol,
                 pT->chrs,
		 lc[lp],
		 (lStatus & 3) ? "Capture " : "",
		 (lStatus & 4) ? "Send " : "",
		 (ScreenMode) ? "Off" : "",
                 eol[bRXEOL], eol[bTXEOL], (bWrap) ? 'w' : ' ',
		 (oflag) ? '1' : ' ');

	nb = aw1.xsize/6-1;
	*(txt+nb) = 0;

	sd_pixp (pStId, -1, 8, 1);
	io_sstrg (pStId, -1, txt, strlen (txt));
	ScreenStat ();
	sd_clrrt (pStId, -1);
/****	LogMsg(txt); LogMsg("\n"); ****/
    }
}

OutError (char *ctl,...)
{
    va_list va;
    char t[80];

    va_start (va, ctl);

    vsprintf (t, ctl, va);
    va_end (va);

    if (QAwake)
    {
	sd_pixp (pStId, -1, 8, 1);
	io_sstrg (pStId, -1, t, (short) strlen (t));
	sd_clrrt (pStId, -1);
	bErrMsg = TRUE;
    }
}

#ifdef REPORT
void debug (char *ctl,...)
{
    static int fd = 0;
    
    va_list va;
    char t[80];

    if(fd == 0)
    {
        fd = io_open("win2_tmp_ql.log", 3);
    }
    va_start (va, ctl);
    vsprintf (t, ctl, va);
    va_end (va);
    io_sstrg (fd, -1, t, (short) strlen (t));
}
#endif
QErr (char *txt, int error)
{
    error = -error;
    if (error < 0 || error > os_nerr)
    {
	error = 0;
    }
    OutError ("%s : %s", txt, os_errlist[error]);
}
static long ASUB (struct WM_wwork *wwk, struct WM_litm *li)
{
    if (ast3.chid)
    {
	ProcessDial (wwk);
    }
    return 0;
}
void DialLoop ()
{
    short cnt;
    int t;
    char txt[64];

    cnt = qC->dTry;

    SrvStats("Dialing %s", CheckPhone (pPhoneNo));

    while (qC->dState)
    {
        t = time(NULL);
	if (t  > qC->dTime)
	{
	    cnt--;
	    if (cnt <= 0)
	    {
		qC->dState = 0;
		SrvStats("Idle");
	    }
	    else
	    {
                pS->SendChr('\r');
		ReDial ("");
	    }
	}
	else
	{
	    t = qC->dTime - t;
            if(qC->dState == Q_WAIT)
            {
                if(cnt <= 1)
                {
                    qC->dState = 0;
		    SrvStats("Idle");
                }
                else
                {
                    qC->dState = Q_DIAL;
                }
            }
	    else if(qC->dState == Q_DONE)
	    {
		qC->dState = 0;
	    }
	    
	    if(!iconic)
	    {
		sprintf (txt, "%2d", cnt);
		sd_pos (ast3.chid, -1, 1, 0);
		io_sstrg (ast3.chid, -1, txt, (short) strlen (txt));
		sprintf (txt, "%03d", t);
		sd_pos (ast3.chid, -1, 0, 1);
		io_sstrg (ast3.chid, -1, txt, (short) strlen (txt));
	    }
	    
	}
	if(qC->dState) mt_susjb (-1, 50, NULL);
    }
    qC->dState = 0;
    qC->qJobId = 0;
    if(!iconic)
    {
	sd_clear (ast3.chid, -1);
	io_close (ast3.chid);
	ast3.chid = -1;
	pick(pChId, -1, QTpid, K_WAKE);
    }
    return;
}
static ResetDialler (struct WM_wwork * wwk)
{
    abell = 0;
    qC->dState = 0;
    if(!iconic)
    {
	litm[LIT_WATCH].pobj = (char *) &mes_null;
	litm[LIT_WATCH].type = 2;
	ws.litem[LIT_WATCH] = WSI_MKAV;
	wm_ldraw (wwk, -1);
	ws.litem[LIT_WATCH] = WSI_UNAV;
    }
    
}
static ProcessDial (struct WM_wwork *wwk)
{
    int n;
    Blocked = 1;
    n = menu_choice (wwk, "Dialing Options", 3, 0, "Online", "Abort", "Quit");
    if(n >= 0)
    {
        switch (n)
        {
	    case 2:
                pS->SendChr('\r');
	        ParseString (MdmCtrl[0], (int (*)(char, char **)) pS->SendChr, 1, NULL);
	    case 1:
                GoOffLine();
	        break;
	    case 0:
	        GoOnLine ();
	        break;
        }
        ResetDialler (wwk);
    }
    Blocked = 0;
}
static int StartDialJob (struct WM_wwork *wwk)
{
    int chid = 0;   

    DoDialJob = 0;

    if(!iconic)
    {
	chid = io_open ("scr", 0);
	wm_swdef (wwk, (wwk->pappl + 0)->pappw, chid);
	sd_setin(chid, -1, 7);

	ws.litem[LIT_WATCH] = WSI_MKAV;
	if(mono)
	{
	    litm[LIT_WATCH].pobj = (char *) &WATCH;
	    litm[LIT_WATCH].type = 0;
	}
	else
	{
	    litm[LIT_WATCH].pobj = (char *) &mes_watch;
	    litm[LIT_WATCH].type = 2;
	}

	wm_ldraw (wwk, -1);
	ws.litem[LIT_WATCH] = WSI_AVBL;
    }
    
    abell = 1;

    qC->dState = Q_DIAL;
    if (qC->dTry > 0 && qC->dWait > 0)
    {
        if (qC->qJobId == 0)
        {
	    qC->qJobId = jcall (DialLoop, "<QTPI Dial>", 2, 2048, 0, NULL);
        }
    }
    ast3.chid = chid;
    return chid;
}

void PosText (void)
{
    if (csr)
    {
	if(dbflag & 0x60)
	{
	    aw0.pspr = (char *) &MES_CURSOR;
	    sd_pxenq (pChId, -1, &rct);
	    setptr (pChId, -1, (short *) &rct.q_x, (short *) &rct.q_y, -1);
	}
	else
	{
	    sd_cure(pChId, -1);
	}
    }
}

void PosNull (void)
{
    if(dbflag & 0xe0)
    {
	aw0.pspr = (char *) &mes_null;
    }
}

void HoldSiblings(void)
{
    mt_susjb (SerJID, -1, NULL);
    mt_susjb (ClkPID, -1, NULL);
    if(qC->qJobId)
    {
	mt_susjb (qC->qJobId, -1, NULL);
    }
}

void RelSiblings(void)
{
    mt_reljb (SerJID);
    mt_reljb (ClkPID);
    if(qC->qJobId)
    {
	wm_swdef (&ww, &aw3, ast3.chid);
	mt_reljb (qC->qJobId);
    }
    else
    {
	ws.litem[LIT_WATCH] = WSI_UNAV;	
    }	
}

static long AMOVE (struct WM_wwork *wwk)
{
    short dx, dy;
    struct QLRECT rct;
    unsigned char zz = (unsigned char) *(short *)(_sys_var + 0x8a);

    lit_reset (wwk, LIT_MOVE);
#ifdef LOGMSGS
    LogMsg("Move, press = %d, zz = %d\n", wwk->wstat->kprs, zz);
#endif
    if(wwk->wstat->kprs || zz == 0xf5)
    {
	HoldSiblings();
        sd_pxenq (pChId, -1, &rct);
        wwk->wstat->evnt |= PT_WMOVE;	/* set event bit for wm_chwin */
        wm_chwin (wwk, &dx, &dy);	/* move window */
        ADRAW (wwk, &aw2);
        ADRAW (wwk, &aw1);
        ADRAW (wwk, &aw0);
        sd_pixp (pChId, -1, rct.q_x, rct.q_y);
	RelSiblings();
        pick(pChId, -1, QTpid, K_WAKE);
        MakePoint();
        PosText();
        PosText();
    }
    else if (zz == 0x05)
    {
        ProcessInput(zz);
    }
    return 0;
}

static void newsize (WM_wwork_t *wwk)
{
    extern long scaler(WM_wwork_t *, short, short);
    short dx,dy;

    HoldSiblings();

    ws.litem[LIT_WATCH] = WSI_MKAV;
    ws.litem[LIT_QUIT] = WSI_MKUN;


    if (mvwin[1] == 'l')
    {
	dx = 480;
    }
    else
    {
	dx = wwk->wscale->xmax - 32;
	if(dx > (132*6))
	{
	    dx = (132*6);
	}
    }
    dx = dx - (aw0.xsize-4);
    dy = 0;
    scaler(wwk, dx, dy);
    ws.litem[LIT_QUIT] = WSI_AVBL;
    RelSiblings();
	
    mt_reljb (SerJID);
    mt_reljb (ClkPID);
    scrY = aw0.ysize/10;
    scrX = aw0.xsize/6;
}

static long do_size (struct WM_wwork *wwk)
{
    short dx, dy;
    struct QLRECT rct;
    unsigned char zz = (unsigned char) *(short *)(_sys_var + 0x8a);

#ifdef LOGMSGS
    LogMsg("Size, press = %d, zz = %d\n", wwk->wstat->kprs, zz);
#endif

    if(wwk->wstat->kprs || zz == 0xf1)
    {
	void *p;
	int n;
	short cdef[4];

	HoldSiblings();
	ws.litem[LIT_WATCH] = WSI_MKAV;
	ws.litem[LIT_QUIT] = WSI_MKUN;
	n = SaveContext(pChId, &p, cdef); 
	re_size(wwk, LIT_SIZE, 1);
	if(n == 0)
	{
	    RestoreContext(pChId, p, cdef, 0);
	}
	ws.litem[LIT_QUIT] = WSI_AVBL;
	RelSiblings();
	scrY = aw0.ysize/10;
	scrX = aw0.xsize/6;
	return 1;
   }
    else if (zz == 0x06)
    {
	lit_reset (wwk, LIT_SIZE);
	return 0;
    }
}

long ASLEEP (struct WM_wwork *wwk)
{
    unsigned char zz = (unsigned char) *(short *)(_sys_var + 0x8a);

    lit_reset (wwk, LIT_SLEEP);

    if(wwk->wstat->kprs || zz == 0xe9)
    {
        if(abell)
        {
            OutError("Not now, I'm busy");
            return 0;
        }
        else
        {
            return PT__ZZZZ;
        }
    }
    else if(zz == 0x07)
    {
        ProcessInput(zz);
    }
    return 0;
}

long ADUMMY (struct WM_wwork *wwk)
{
    unsigned char zz = (unsigned char) *(short *)(_sys_var + 0x8a);
    lit_reset (wwk, LIT_HELP);
    ProcessInput(zz);
    return 0;
}

#ifdef THREAD_SAFE
void *xmalloc( int n)
{
    char *p = NULL;

    if(n)
    {
	long m;
	
	p = mt_alchp(n, &m, -1);
	if((long)p <= 0)
	{
	    exit((long)p);
	}
	memset(p, '\0', n);
    }
    return p;
}
void xfree(void *p)
{
    mt_rechp(p);
}
#else
#include <lock.h>

static LOCK lck = {0};

void *xmalloc( int n)
{
    char *p = NULL;
    
    if(n)
    {
	GetLock0(lck);
	if((p = calloc(n, 1)) == NULL)
	{
	    exit (-3);
	}
	FreeLock0(lck);
    }	
    return p;
}
void xfree(void *p)
{
    GetLock0(lck);
    free (p);
    FreeLock0(lck);
}
#endif
char *mystrdup(const char *s)
{
    char *d;
    d = xmalloc(strlen(s)+1);
    if(d)
    {
	strcpy(d, s);
    }
    return d;
}
