/*
 * $Log: qtpmenu.c,v $
 * Revision 1.5  1998/01/18 18:54:20  jrh
 * for 1.63 release
 *
 * Revision 1.4  1997/08/23 21:13:39  jrh
 * pre config removal
 *
 * Revision 1.3  1996/12/23 22:33:01  jrh
 * Checkin for 1.62
 *
 * Revision 1.2  1996/07/09  12:25:57  jrh
 * post fsel (1.60)
 *
 * Revision 1.1  1995/09/16  17:22:18  root
 * Initial login under Linux
 *
 * Revision 1.15  1995/04/08  20:53:27  jrh
 * Add Thing functionality
 *
 * Revision 1.14  1995/04/01  00:02:26  jrh
 * Fix resized menu redraw bug
 *
 * Revision 1.13  1995/03/31  21:21:23  jrh
 * Add User menu code and icon
 *
 * Revision 1.12  1995/03/31  12:21:52  jrh
 * Fix mallocs to use xmalloc
 *
 * Revision 1.11  1995/03/27  21:58:47  jrh
 * Fix Blank menus (please...)
 *
 * Revision 1.10  1995/03/24  16:29:31  jrh
 * Menu code
 *
 * Revision 1.9  1995/03/18  12:15:37  jrh
 * C68 v4.5
 *
 * Revision 1.8  1995/03/13  22:13:34  jrh
 * Added init/exit scripting
 *
 * Revision 1.7  1995/03/12  23:00:08  jrh
 * scripting
 *
 * Revision 1.6  1995/02/12  18:03:25  jrh
 * beta for scripting
 *
 * Revision 1.5  1995/02/07  16:52:32  jrh
 * Add send file expansions
 *
 * Revision 1.4  1994/12/25  13:41:44  jrh
 * Don't upload NULL filenames
 *
 * Revision 1.3  1994/12/15  21:31:12  jrh
 * delay for QXL,slow modems
 *
 * Revision 1.2  1994/05/31  22:19:55  jrh
 * c68 v4.13c fixes
 *
 * Revision 1.1  1994/05/30  21:43:08  jrh
 * Initial checkin at v1.33
 *
 */

#ifndef beep
#define beep _beep
#define do_sound _do_sound
#endif

static char rcsid[] ="$Id: qtpmenu.c,v 1.5 1998/01/18 18:54:20 jrh Exp $";

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <qdos.h>
#include <qptr.h>
#include <qlib.h>

#include "defs.h"

#define RETITM 39

Prototype MenuFiles (struct WM_wwork *);
Prototype MenuPrefs (struct WM_wwork *);
Prototype MenuModem (struct WM_wwork *);
Prototype MenuXfer (struct WM_wwork *);
Prototype MiscMenu (struct WM_wwork *);
Prototype char *XPRMenu (struct WM_wwork *);
Prototype PrefsComMenu (struct WM_wwork *, int);
Prototype int GetFileName (struct WM_wwork *, char *, char *, int, int, int);
Local int exists (char *p);

static long MACAP (struct WM_wwork *wwk, struct WM_menw *mw, char *mst, short col, short row);
static long MASEND (struct WM_wwork *wwk, struct WM_menw *mw, char *mst, short col, short row);
static long MMINNY (struct WM_wwork *wwk, struct WM_menw *mw, char *mst, short col, short row);
static long MULOAD(struct WM_wwork *wwk, struct WM_menw *mw, char *mst, short col, short row);
static long MDLOAD(struct WM_wwork *wwk, struct WM_menw *mw, char *mst, short col, short row);
static long MXPROP(struct WM_wwork *wwk, struct WM_menw *mw, char *mst, short col, short row);
static long MXPRPR(struct WM_wwork *wwk, struct WM_menw *mw, char *mst, short col, short row);
static long MESC (struct WM_wwork *wwk, struct WM_litm *li);
static long MREV(struct WM_wwork *wwk, struct WM_menw *mw, char *mst, short col, short row);

static struct WM_action mesc = {JSR, wm_actli, MESC};
static struct WM_action macap = {JSR, wm_actme, MACAP};
static struct WM_action masend = {JSR, wm_actme, MASEND};
static struct WM_action mminny = {JSR, wm_actme, MMINNY};
static struct WM_action muload = {JSR, wm_actme, MULOAD};
static struct WM_action mdload = {JSR, wm_actme, MDLOAD};
static struct WM_action mxprop = {JSR, wm_actme, MXPROP};
static struct WM_action mxprpr = {JSR, wm_actme, MXPRPR};
static struct WM_action mrev = {JSR, wm_actme, MREV};

static long MDIAL(struct WM_wwork *wwk, struct WM_menw *mw, char *mst, short col, short row);
static struct WM_action mdial = {JSR, wm_actme, MDIAL};

static long MPREFS(struct WM_wwork *wwk, struct WM_menw *mw, char *mst, short col, short row);
static long MPFILES(struct WM_wwork *wwk, struct WM_menw *mw, char *mst, short col, short row);
static long MPMODEM(struct WM_wwork *wwk, struct WM_menw *mw, char *mst, short col, short row);

static struct WM_action mprefs = {JSR, wm_actme, MPREFS};
static struct WM_action mpfiles = {JSR, wm_actme, MPFILES};
static struct WM_action mpmodem = {JSR, wm_actme, MPMODEM};

static long PMOPEN (struct WM_wwork *wwk, struct WM_menw *mw, char *mst, short col, short row);
static long PMSAVE (struct WM_wwork *wwk, struct WM_menw *mw, char *mst, short col, short row);
static long PMSAVEAS (struct WM_wwork *wwk, struct WM_menw *mw, char *mst, short col, short row);
static long PMDEFAULTS (struct WM_wwork *wwk, struct WM_menw *mw, char *mst, short col, short row);
static long PMINIT (struct WM_wwork *wwk, struct WM_menw *mw, char *mst, short col, short row);

static struct WM_action pmopen = {JSR, wm_actme, PMOPEN};
static struct WM_action pmsave = {JSR, wm_actme, PMSAVE};
static struct WM_action pmsaveas = {JSR, wm_actme, PMSAVEAS};
static struct WM_action pmdefaults = {JSR, wm_actme, PMDEFAULTS};
static struct WM_action pminit = {JSR, wm_actme, PMINIT};

static QD_TEXTI (ESCAPE, "Esc");

static QD_TEXTI (fm0, "Capture All ...");
static QD_TEXTI (fm1, "Capture Now ...");
static QD_TEXTI (fm2, "Send Text ...");
static QD_TEXTI (fm3, "Up Load ...");
static QD_TEXTI (fm4, "Down Load ...");
static QD_TEXTI (fm5, "XPR Protocol ...");
static QD_TEXTI (fm6, "XPR Prefs ...");
static QD_TEXTI (fm7, "File Options ...");
static QD_TEXTI (fm8, "Review Buffer");
static QD_TEXTI (fm9, "Xfer Buffer");
static QD_TEXTI (fmA, "Run External");

static MDEF Fm[] =
{
    {(struct QD_text *) &fm0, -1, WSI_AVBL, PT_CAN, &macap},
    {(struct QD_text *) &fm1, -2, WSI_AVBL, PT_CAN, &macap},
    {(struct QD_text *) &fm2, -1, WSI_AVBL, PT_CAN, &masend},
    {(struct QD_text *) &fm3, -1, WSI_AVBL, PT_CAN, &muload},
    {(struct QD_text *) &fm4, -1, WSI_AVBL, PT_CAN, &mdload},
    {(struct QD_text *) &fm5, -1, WSI_AVBL, 0, &mxprpr},
    {(struct QD_text *) &fm6, -2, WSI_AVBL, 0, &mxprop},
    {(struct QD_text *) &fm7, -1, WSI_AVBL, 0, &mpfiles},
    {(struct QD_text *) &fm8, -1, WSI_AVBL, PT_CAN, &mrev},
    {(struct QD_text *) &fm9, -3, WSI_AVBL, PT_CAN, &mrev},
    {(struct QD_text *) &fmA, -3, WSI_AVBL, PT_CAN, &mminny}
};

extern LLIST _FMenu_[];
LLIST _FMenu_[] =
{
    {&_FMenu_[1], &Fm[0]},
    {&_FMenu_[2], &Fm[1]},
    {&_FMenu_[3], &Fm[2]},
    {&_FMenu_[4], &Fm[3]},
    {&_FMenu_[5], &Fm[4]},
    {&_FMenu_[6], &Fm[5]},
    {&_FMenu_[7], &Fm[6]},
    {&_FMenu_[8], &Fm[7]},
    {&_FMenu_[9], &Fm[8]},
    {&_FMenu_[10], &Fm[9]},
    {NULL,        &Fm[10]}
};

#define FMITEMS 11

static QD_TEXTI (mm0, "Dial ...");
static QD_TEXTI (mm1, "Disconnect");
static QD_TEXTI (mm2, "Connect");
static QD_TEXTI (mm3, "Answer");
static QD_TEXTI (mm4, "Auto Answer");
static QD_TEXTI (mm5, "Reset Line");
static QD_TEXTI (mm6, "Version");
static QD_TEXTI (mm7, "AT Strings ...");

static MDEF Mm[] =
{
    {(struct QD_text *) &mm0, -1, WSI_AVBL, PT__CAN, &mdial},
    {(struct QD_text *) &mm1, -2, WSI_AVBL, 0, &mdial},
    {(struct QD_text *) &mm2, -1, WSI_AVBL, 0, &mdial},
    {(struct QD_text *) &mm3, -1, WSI_AVBL, 0, &mdial},
    {(struct QD_text *) &mm4, -2, WSI_AVBL, 0, &mdial},
    {(struct QD_text *) &mm5, -1, WSI_AVBL, 0, &mdial},
    {(struct QD_text *) &mm6, -1, WSI_AVBL, 0, &mdial},
    {(struct QD_text *) &mm7, -2, WSI_AVBL, 0, &mpmodem}
};

extern LLIST _MMenu_[];
LLIST _MMenu_[] =
{
    {&_MMenu_[1], &Mm[0]},
    {&_MMenu_[2], &Mm[1]},
    {&_MMenu_[3], &Mm[2]},
    {&_MMenu_[4], &Mm[3]},
    {&_MMenu_[5], &Mm[4]},
    {&_MMenu_[6], &Mm[5]},
    {&_MMenu_[7], &Mm[6]},
    {NULL,        &Mm[7]}
};

#define MMITEMS 8

static QD_TEXTI (pm0, "Open ...");
static QD_TEXTI (pm1, "Save");
static QD_TEXTI (pm2, "Save As ...");
static QD_TEXTI (pm3, "Defaults");
static QD_TEXTI (pm4, "Init Modem");

static MDEF Pm[] =
{
    {(struct QD_text *) &pm0, -1, WSI_AVBL, 0, &pmopen},
    {(struct QD_text *) &pm1, -1, WSI_AVBL, 0, &pmsave},
    {(struct QD_text *) &pm2, -2, WSI_AVBL, 0, &pmsaveas},
    {(struct QD_text *) &pm3, -1, WSI_AVBL, 0, &pmdefaults},
    {(struct QD_text *) &pm4, -1, WSI_AVBL, 0, &pminit}
};

extern LLIST _PMenu_[];
LLIST _PMenu_[] =
{
    {&_PMenu_[1], &Pm[0]},
    {&_PMenu_[2], &Pm[1]},
    {&_PMenu_[3], &Pm[2]},
    {&_PMenu_[4], &Pm[3]},
    {NULL,        &Pm[4]}
};

#define PMITEMS 5

static QD_TEXTI (lm0, "Answerback");
static QD_TEXTI (lm1a, "Reset Terminal");
static QD_TEXTI (lm1, "Clear Terminal");
static QD_TEXTI (lm2, "Output Toggle");
static QD_TEXTI (lm3, "ReDial");
static QD_TEXTI (lm4, "Default Log");

static MDEF Lm[] =
{
    {(struct QD_text *) &lm0, -1, WSI_AVBL, 0, NULL},
    {(struct QD_text *) &lm1a, -3, WSI_AVBL, 0, NULL},
    {(struct QD_text *) &lm1, -1, WSI_AVBL, 0, NULL},
    {(struct QD_text *) &lm2, -1, WSI_AVBL, 0, NULL},
    {(struct QD_text *) &lm3, -1, WSI_AVBL, 0, NULL},
    {(struct QD_text *) &lm4, -1, WSI_AVBL, 0, NULL}
};

extern LLIST _LMenu_[];
LLIST _LMenu_[] =
{
    {&_LMenu_[1], &Lm[0]},
    {&_LMenu_[2], &Lm[1]},
    {&_LMenu_[3], &Lm[2]},
    {&_LMenu_[4], &Lm[3]},
    {&_LMenu_[5], &Lm[4]},
    {NULL,        &Lm[5]}
};

#define LMITEMS 6

static QD_TEXTI (gm0, "Connection ...");
static QD_TEXTI (gm1, "Files ...");
static QD_TEXTI (gm2, "Modem ...");

static MDEF Gm[] =
{
    {(struct QD_text *) &gm0, -1, WSI_AVBL, 0, &mprefs},
    {(struct QD_text *) &gm1, -1, WSI_AVBL, 0, &mpfiles},
    {(struct QD_text *) &gm2, -1, WSI_AVBL, 0, &mpmodem}
};

extern LLIST _GMenu_[];
LLIST _GMenu_[] =
{
    {&_GMenu_[1], &Gm[0]},
    {&_GMenu_[2], &Gm[1]},
    {NULL,        &Gm[2]}
};

#define GMITEMS 3

struct WM_litm DD_litm[2] =	/* loose item */
{
    {24, 10,			/* xsize, ysize         size */
     100, 2,			/* xorg, yorg           and origin */
     0, 0,			/* xjst, yjst           justification */
     TYP_TEXT, 3,		/* type, skey           type and select key */
     &ESCAPE,			/* *pobj                pointer to object */
     0,				/* item                 item number */
     &mesc},			/* *pact                pointer to action */
    {-1, -1}
};

extern short Iserve;

static void resetobj(struct WM_wwork *wwk, struct WM_menw *mw, char *mst, short item)
{
    mst[item] = WSI_MKAV;
    wm_mdraw (wwk, (struct WM_swdef *) mw, -1);
    mst[item] = WSI_AVBL;
}

MenuFiles (struct WM_wwork *wwk)
{
    int opt;
    LLIST *p = _FMenu_;
    Fm[6].status = (XPRPid) ? WSI_AVBL : WSI_UNAV;
    Fm[9].status = (Iserve) ? WSI_AVBL : WSI_UNAV;
    opt = menu (wwk, "Files Menu", &p, FMITEMS, 50, 50, 160, 0, DD_litm, 1);
    return opt;
}

MenuPrefs (struct WM_wwork * wwk)
{
    int opt;
    LLIST *p = _GMenu_;
    opt = menu (wwk, "Preferences Menu", &p, GMITEMS, 50, 50, 160, 0, DD_litm, 1);
    return opt;
}

MenuModem (struct WM_wwork * wwk)
{
    int opt;
    LLIST *p = _MMenu_;
    opt = menu (wwk, "Modem Menu", &p, MMITEMS, 50, 50, 160, 0, DD_litm, 1);
    return opt;
}

MiscMenu (struct WM_wwork * wwk)
{
    int opt;
    LLIST *p = _LMenu_;
    opt = menu (wwk, "Miscellaneous", &p, LMITEMS, 50, 50, 160, 0, DD_litm, 1);
    if (opt != -1)
    {
	DoMiscAct (opt);
    }
    return 0;
}

char *XPRMenu (struct WM_wwork *wwk)
{
    int nX, n;
    PLLIST _XMenu_ = NULL;
    static char p[20];
    char *rp;

    nX = BuildXMenu (&_XMenu_);
    if (nX)
    {
	n = menu (wwk, "XPR Protocol", &_XMenu_, nX, 50, 50, 120, nX*12, DD_litm, 1);
	if (n < 0)
	{
	    rp = NULL;
	}
	else
	{
	    PLLIST pz;
	    struct QD_text *s;
	    PMDEF pi;
	    int i;
	    char *c;

	    for (pz = _XMenu_, i = 0; i < n && pz; i++)
	    {
		pz = pz->next;
	    }
	    pi = (PMDEF) pz->item;
	    s = pi->qtext;
	    c = (char *) s->chrs;
	    if (pz == _XMenu_)
	    {
		rp = "";
	    }
	    else
	    {
		strncpy (p, c, 19);
		rp = p;
	    }
	}
        FreeXList (&_XMenu_);
    }
    else
    {
	menu_choice (wwk, "Can't find any XPR libraries", 1, 0, "OK");
	rp = NULL;
    }
    return rp;
}
PrefsComMenu (struct WM_wwork * wwk, int pflag)
{
    int i, n;
    LLIST *p = _PMenu_;
    
    for (i = 0; i < PMITEMS; i++)
    {
	if (pflag & (1 << i))
	{
	    ((PMDEF) (_PMenu_ + i)->item)->status = WSI_UNAV;
	}
	else
	{
	    ((PMDEF) (_PMenu_ + i)->item)->status = WSI_AVBL;
	}
    }

    n = menu (wwk, "Commands", &p, PMITEMS, 50, 50, 160, 0, DD_litm, 1);

    if (n == 0 || n == 3)
    {
	return 1;
    }
    else
    {
	return 0;
    }
}

static long MACAP (struct WM_wwork *wwk, struct WM_menw *mw, char *mst, short col, short row)
{
    struct WM_mobj *mobj;
    int this_opt;

    mobj = mw->rowl[row].rows;	/* current menu object */
    this_opt = DoCaptureItem (wwk, mobj->item, 1);
    if (this_opt == -1)
    {
	wwk->wstat->litem[RETITM] = -1;
        resetobj(wwk, mw, mst, mobj->item);
	return 0;
    }
    else
    {
	wwk->wstat->litem[RETITM] = mobj->item;
	return PT__CAN;
    }
}
static long MREV (struct WM_wwork *wwk, struct WM_menw *mw, char *mst, short col, short row)
{
    struct WM_mobj *mobj;
    CAPDEF_t *c;

    mobj = mw->rowl[row].rows;	/* current menu object */

    c = (mobj->item == 8) ? &Cap : &Xfr;

    if (wwk->wstat->kprs == K_DO)
    {
        c->wake = 1;
    }
    else
    {
        c->wake = 0;
    }
    wwk->wstat->litem[RETITM] = mobj->item;
    return PT__CAN;
}
   
static long MASEND (struct WM_wwork *wwk, struct WM_menw *mw, char *mst, short col, short row)
{
    struct WM_mobj *mobj;
    int this_opt;

    mobj = mw->rowl[row].rows;	/* current menu object */
    this_opt = DoSendItem (wwk, 1);
    if (this_opt == -1)
    {
	wwk->wstat->litem[RETITM] = -1;
        resetobj(wwk, mw, mst, mobj->item);
	return 0;
    }
    else
    {
	wwk->wstat->litem[RETITM] = mobj->item;
	return PT__CAN;
    }
}

extern  int RunScript(char *, short, char *);

static long MMINNY (struct WM_wwork *wwk, struct WM_menw *mw, char *mst, short col, short row)
{

    struct WM_mobj *mobj;
    int this_opt;
    char QName[60];
    int n = 0;
    int rv = 0;
    static char *prompt = "Run External";
    static char def[40] = {0};
    
    mobj = mw->rowl[row].rows;	/* current menu object */
    if(useFS)
    {
	this_opt = GetMenuFile(prompt, def, QName);
    }
    else
    {
	*QName = 0;
	this_opt = menu_text (wwk, prompt, QName, 60);
    }
    
    if (this_opt != -1 && *QName)
    {
        char *opt;
        if((opt = strchr(QName, ';')) != NULL)
        {
            *opt = '\0';
            opt++;
        }
	wwk->wstat->litem[RETITM] = mobj->item;
        if(RunScript (QName, 0, opt) == 0)
        {
       	    rv = PT__CAN;
	}
	if(rv == 0)
	{
            menu_choice (wwk, "Sorry, can't do that", 1, 0, "Continue");
	}
    }
    resetobj(wwk, mw, mst, mobj->item);
    return rv;
}

extern int MakeFileList (char *);

static long MULOAD (struct WM_wwork *wwk, struct WM_menw *mw, char *mst, short col, short row)
{
    struct WM_mobj *mobj;
    int this_opt;
    char QName[60];
    int n = 0;
    static char *prompt = "Up Load";

    mobj = mw->rowl[row].rows;	/* current menu object */
    if(useFS)
    {
	this_opt = GetMenuFile(prompt, XmSFile, QName);
    }
    else
    {
	strcpy (QName, XmSFile);
	this_opt = menu_text (wwk, prompt, QName, 60);
    }
    
    if (this_opt != -1 && *QName)
    {
	wwk->wstat->litem[RETITM] = mobj->item;
	strcpy (BaseName, QName);
        n = MakeFileList(BaseName);
        if(n > 0)
        {
            char txt[80];
            sprintf(txt, "F10 or Xfer Icon to Upload (%d files)", n);
            beep(2000,20);
            OutError(txt);
	    return PT__CAN;
        }
        else
        {
            n = 0;
            menu_choice (wwk, "No Files selected", 1, 0, "Continue");
	}        
    }

    if(n == 0) 
    {
	wwk->wstat->litem[RETITM] = -1;
        resetobj(wwk, mw, mst, mobj->item);
	return 0;
    }


}
static long MDLOAD (struct WM_wwork *wwk, struct WM_menw *mw, char *mst, short col, short row)
{
    struct WM_mobj *mobj;
    int this_opt;
    char QName[60];
    static char *prompt = "Down Load";
    
    mobj = mw->rowl[row].rows;	/* current menu object */
    if((XPRStatus & 2) == 0)
    {
	if(useFS)
	{
	    this_opt = GetMenuFile(prompt, XmRFile, QName);
	}
	else
	{
	    strcpy (QName, XmRFile);
	    this_opt = menu_text (wwk, prompt, QName, 60);
	}
	
        if (this_opt == -1 || *QName == 0)
        {
	    wwk->wstat->litem[RETITM] = -1;
            resetobj(wwk, mw, mst, mobj->item);
	    return 0;
        }
        else
        {
	    strcpy (BaseName, QName);
        }
    }
    wwk->wstat->litem[RETITM] = mobj->item;
    return PT__CAN;
}

static long MXPROP (struct WM_wwork *wwk, struct WM_menw *mw, char *mst, short col, short row)
{
    struct WM_mobj *mobj;

    DoXPROptions (wwk);

    mobj = mw->rowl[row].rows;
    resetobj(wwk, mw, mst, mobj->item);
    return 0;

}
static long MXPRPR (struct WM_wwork *wwk, struct WM_menw *mw, char *mst, short col, short row)
{
    struct WM_mobj *mobj;
    char *s;

    s = XPRMenu (wwk);

    if (s)
    {
	if (stricmp (s, MyProtocol) || XPRPid == 0)
	{
	    bConf = 1;
	    strcpy (MyProtocol, s);
	    XPRStatus = XPRUse (MyProtocol);
	}
    }
    DoStatus ();
    mobj = mw->rowl[row].rows;
    mst[mobj->item] = WSI_MKAV;

    if(XPRPid)
    {
        Fm[6].status = mst[mobj->item+1] = WSI_MKAV;
    }
    else
    {
        Fm[6].status = mst[mobj->item+1] = WSI_MKUN;
    }
    wm_mdraw (wwk, (struct WM_swdef *) mw, -1);
    Fm[6].status &= 0xfe;
    mst[mobj->item+1] &= (char)0xfe;
    mst[mobj->item] &= (char) 0xfe;
    return 0;
}
static long MDIAL (struct WM_wwork *wwk, struct WM_menw *mw, char *mst, short col, short row)
{
    int this_opt;
    struct WM_mobj *mobj;

    mobj = mw->rowl[row].rows;

    this_opt = OnModemMenu (wwk, mobj->item);
    if (this_opt == -1)
    {
        resetobj(wwk, mw, mst, mobj->item);
	return 0;
    }
    else
    {
	return PT__CAN;
    }
}

static long MPMODEM (struct WM_wwork *wwk, struct WM_menw *mw, char *mst, short col, short row)
{
    int this_opt;
    struct WM_mobj *mobj;

    mobj = mw->rowl[row].rows;

    EditModem (wwk);
    resetobj(wwk, mw, mst, mobj->item);
    return 0;
}

static long MPREFS (struct WM_wwork *wwk, struct WM_menw *mw, char *mst, short col, short row)
{
    int this_opt;
    struct WM_mobj *mobj;

    mobj = mw->rowl[row].rows;

    if (EditSetup (wwk))
    {
	SetParams (1);
	DoStatus ();
    }
    resetobj(wwk, mw, mst, mobj->item);
    return 0;
}
static long MPFILES (struct WM_wwork *wwk, struct WM_menw *mw, char *mst, short col, short row)
{
    int this_opt;
    struct WM_mobj *mobj;

    mobj = mw->rowl[row].rows;
    EditFiles (wwk);
    resetobj(wwk, mw, mst, mobj->item);
    return 0;
}

static long PMOPEN (struct WM_wwork *wwk, struct WM_menw *mw, char *mst, short col, short row)
{
    struct WM_mobj *mobj;
    int n;

    n = GetFileName (wwk, "Preference File", QeM_Dat, 40, IO_OLD, 1);
    if (n > 0)
    {
	wwk->wstat->litem[RETITM] = 0;
	pRestore ();
	SetParams (0);
    }
    else
    {
	wwk->wstat->litem[RETITM] = -1;
    }
    return PT__CAN;
}
static long PMSAVE (struct WM_wwork *wwk, struct WM_menw *mw, char *mst, short col, short row)
{
    struct WM_mobj *mobj;
    int n;

    wwk->wstat->litem[RETITM] = 1;

    CleanForSave (wwk);
    pSave ();
    return PT__CAN;
}
static long PMSAVEAS (struct WM_wwork *wwk, struct WM_menw *mw, char *mst, short col, short row)
{
    struct WM_mobj *mobj;
    int n;

    wwk->wstat->litem[RETITM] = 2;

    n = GetFileName (wwk, "Preference File", QeM_Dat, 40, IO_NEW, 1);
    if (n > 0)
    {
	CleanForSave (wwk);
	pSave ();
    }
    return PT__CAN;
}
static long PMDEFAULTS (struct WM_wwork *wwk, struct WM_menw *mw, char *mst, short col, short row)
{
    wwk->wstat->litem[RETITM] = 3;
    pDefault ();
    SetParams (0);
    return PT__CAN;
}
static long PMINIT (struct WM_wwork *wwk, struct WM_menw *mw, char *mst, short col, short row)
{
    wwk->wstat->litem[RETITM] = 4;
    QCInit ();
    return PT__CAN;
}

static int exists (char *p)
{
    int chn;
    int sts = 0;

    if ((chn = io_open (p, 1)) > 0)
    {
	sts = 1;
	io_close (chn);
    }
    return sts;
}
int GetFileName (struct WM_wwork *wwk, char *prompt, char *text,
		 int maxc, int type, int query)
{
    int done = 0;
    int n, k;
    char temp[80];

    /* save user buffer */

    strcpy (temp, text);
    if(useFS)
    {
	n = GetMenuFile(prompt, temp, text);
    }
    else
    {
	do
	{
	    n = menu_text (wwk, prompt, temp, maxc);
	    if (n < 0)
	    {
		done = TRUE;
	    }
	    else
	    {
		if (type == IO_NEW)
		{
		    if (query == FALSE)
		    {
			done = TRUE;
			strcpy (text, temp);
		    }
		    else
		    {
			if (exists (temp))
			{
			    k = menu_choice (wwk, "File exists, overwrite ?",
					     3, 1, "Yes", "No", "Quit");
			    if (k == 0)
			    {
				done = TRUE;
				strcpy (text, temp);
			    }
			    else if (k == 2)
			    {
				done = TRUE;
				n = -1;
			    }
			}
			else
			{
			    done = TRUE;
			    strcpy (text, temp);
			}
		    }
		}
		else
		{
		    if (exists (temp))
		    {
			done = TRUE;
			strcpy (text, temp);
		    }
		    else
		    {
			k = menu_choice (wwk, "File not found",
					 2, 0, "OK", "Quit");
			if (k == 1)
			{
			    done = TRUE;
			    n = -1;
			}
		    }
		}
	    }
	} while (!done);
    }
    return n;
}
static long MESC (struct WM_wwork *wwk, struct WM_litm *li)
{
    wwk->wstat->litem[RETITM] = -1;
    lit_reset (wwk, li->item);
    return PT__CAN;		/* and return CAN event */
}
