/*
 * $Log: xprwin.c,v $
 * Revision 1.6  1997/08/23 21:11:08  jrh
 * pre config removal
 *
 * Revision 1.5  1996/12/23 22:32:00  jrh
 * *** empty log message ***
 *
 * Revision 1.4  1996/07/09  09:26:15  jrh
 * pre file sel (1.599)
 *
 * Revision 1.3  1995/12/30  18:28:09  root
 * For v1.57 (QXL baud, SH status, CSM crash)
 *
 * Revision 1.2  1995/11/12  15:29:37  root
 * Baud rates for QXL etc
 *
 * Revision 1.1  1995/09/16  17:22:18  root
 * Initial login under Linux
 *
 * Revision 1.4  1995/03/12  23:00:08  jrh
 * scripting
 *
 * Revision 1.3  1995/02/07  16:52:32  jrh
 * better wild cards etc
 *
 * Revision 1.2  1994/05/31  22:19:55  jrh
 * c68 v4.13c fixes
 *
 * Revision 1.1  1994/05/30  21:43:47  jrh
 * Initial checkin at v1.33
 *
 */

static char rcsid[] ="$Id: xprwin.c,v 1.6 1997/08/23 21:11:08 jrh Exp $";

#include <stdio.h>
#include <stdlib.h>
#include <qdos.h>
#include <qptr.h>
#include <qlib.h>
#include <stdarg.h>

#include "defs.h"

#include <pd/xproto.h>
#include "xprmsg.h"
#include "wild.h"

static AEXIT (struct WM_wwork *, struct WM_litm *);
static long ADRAW (struct WM_wwork *, struct WM_appw *);
static long AHIT (struct WM_wwork *, struct WM_appw *,
		  struct WM_wstat *, short , short );

static struct WM_action aexit = {JSR, wm_actli, AEXIT};
static struct WM_action adraw = {JSR, wm_drwaw, ADRAW};
static struct WM_action ahit = {JSR, wm_hitaw, AHIT};

static struct WM_wstat ws =	/* window status area */
{
    NULL,			/* *wwork               point back to work def */
    NULL,			/* *wdef                this was wdef */
    0,				/* chid                 chan ID enclosing pointer */
    0, 0, 0,			/* swnr, xpos, ypos     sub-window and ptr posn */
    0, 0,			/* kstk, kprs           key stroke and press */
    0,				/* evnt                 event vector */
    0, 0, 0, 0,			/* xsiz, ysiz, xorg, yorg  */
    0, 0,			/* ptpsx, ptpsy         pointer position (abs) */
    FORM_QL4, 0, 0,		/* wmode, 2 spare       window mode and spare */
    NULL,			/* *ciact               current item "action" */
    -1,				/* citem                current item */
    0, 0, 0,			/* cibrw, cipap, cispr  current item attr */
    0, 0, 0, 0,			/* cihxs,ys, cihxo,yo   current item hit area */
    {0, 0, 0, 0, 0, 0, 0, 0}	/* litem[40]            loose item status */
};

#define ninfw    4		/* number of information windows */
#define ninfo    19		/* number of information objects */
#define nlitm    4		/* number of loose items */
#define nappl    1		/* number of application sub-windows */

static QD_TEXTI (END, "QUIT");
static QD_TEXTI (XTITLE, "XPR Transfer");
static QD_TEXTI (STITLE, "Skip File");
static QD_TEXTI (ATITLE, "Abort Transfer");

static QD_TEXTI (xt00, "Protocol       :");
static QD_TEXTI (xt01, "File           :");
static QD_TEXTI (xt02, "Size           :");
static QD_TEXTI (xt03, "Bytes Sent     :");
static QD_TEXTI (xt04, "Block Check    :");
static QD_TEXTI (xt05, "Estimated Time :");
static QD_TEXTI (xt06, "Message        :");
static QD_TEXTI (xt07, "Last Error     :");
static QD_TEXTI (xt08, "No Errors      :");
static QD_TEXTI (xt09, "Packet Type    :");
static QD_TEXTI (xt10, "Char/Sec       :");
static QD_TEXTI (xt11, "Blocks Sent    :");
static QD_TEXTI (xt12, "Block Size     :");
static QD_TEXTI (xt13, "Elapsed Time   :");
static QD_TEXTI (xt14, "No Timeouts    :");
static QD_TEXTI (xt15, "Packet Delay   :");
static QD_TEXTI (xt16, "Char Delay     :");
static QD_TEXTI (xt17, "Time remaining :");
static struct WM_info tinfo[2] =
{
    {78, 10, 3, 1, 0, 0,   {0, 0, 0}, &XTITLE},
    {-1, -1}
};

static struct WM_info xinfo[] =
{
    {96, 10, 12,   0, 0, 0,     {4, 0, 0}, &xt00},
    {96, 10, 12,  10, 0, 0,     {4, 0, 0}, &xt01},
    {96, 10, 12,  20, 0, 0,     {4, 0, 0}, &xt02},
    {96, 10, 12,  30, 0, 0,     {4, 0, 0}, &xt03},
    {96, 10, 12,  40, 0, 0,     {4, 0, 0}, &xt04},
    {96, 10, 12,  50, 0, 0,     {4, 0, 0}, &xt05},
    {96, 10, 12,  60, 0, 0,     {4, 0, 0}, &xt06},
    {96, 10, 12,  70, 0, 0,     {4, 0, 0}, &xt07},
    {96, 10, 12,  80, 0, 0,     {4, 0, 0}, &xt08},
    {96, 10, 12,  90, 0, 0,     {4, 0, 0}, &xt09},
    {96, 10, 12, 100, 0, 0,     {4, 0, 0}, &xt10},

    {96, 10, 240, 20, 0, 0,     {4, 0, 0}, &xt17},
    {96, 10, 240, 30, 0, 0,     {4, 0, 0}, &xt11},
    {96, 10, 240, 40, 0, 0,     {4, 0, 0}, &xt12},
    {96, 10, 240, 50, 0, 0,     {4, 0, 0}, &xt13},
    {96, 10, 240, 80, 0, 0,     {4, 0, 0}, &xt14},
    {96, 10, 240, 90, 0, 0,     {4, 0, 0}, &xt15},
    {96, 10, 240, 100, 0, 0,    {4, 0, 0}, &xt16},
    {-1, -1}
};

static struct WM_infw infw[ninfw + 1] =	/* information window */
{
    {438, 15,			/* xsize, ysize         size */
     0, 0,			/* xorg, yorg           and origin */
     0,				/* flag                 no clear + shadow */
     0, 0, 84,			/* borw, borc, papr     border width/clr,paper */
     NULL},			/* *pobj                pointer to object list */
    {84, 12,			/* xsize, ysize         size */
     180, 1,			/* xorg, yorg           and origin */
     0,				/* flag                 no clear + shadow */
     0, 0, 7,			/* borw, borc, papr     border width/clr,paper */
     tinfo},			/* *pobj                pointer to object list */
    {438, 15,			/* xsize, ysize         size */
     0, 135,			/* xorg, yorg           and origin */
     0,				/* flag                 no clear + shadow */
     0, 0, 84,			/* borw, borc, papr     border width/clr,paper */
     NULL},			/* *pobj                pointer to object list */
    {438, 120,			/* xsize, ysize         size */
     0, 15,			/* xorg, yorg           and origin */
     0,				/* flag                 no clear + shadow */
     0, 0, 0,			/* borw, borc, papr     border width/clr,paper */
     xinfo},			/* *pobj                pointer to object list */
    {-1}			/* end of array */
};

extern int mes_slep, ASLEEP ();
static struct WM_action asleep = {JSR, wm_actli, ASLEEP};

static struct WM_litm litm[nlitm + 1] =	/* loose item */
{
    {26, 10, 380, 2, 0, 0, 0, 3, &END, 0, &aexit},
    {22, 10, 2, 2, 0, 0, 2, K_SLEEP, &mes_slep, LIT_SLEEP, &asleep},
    {188, 10, 20, 138, 0, 0, -1, 'S', &STITLE, 2, &aexit},
    {188, 10, 230, 138, 0, 0, -1, 'A', &ATITLE, 3, &aexit},
    {-1}
};

static struct WM_appw aw0 =	/* application sub-window */
{
    438, 120,			/* xsize, ysize         size */
    0, 15,			/* xorg, yorg           and origin */
    NO_WCLEAR,			/* flag                 no clear + shadow */
    0, 0, 0,			/* borw, borc, papr     border width/clr, paper */
    NULL,			/* *pspr                pointer to sprite */
    &adraw,			/* *draw                draw routine */
    &ahit,			/* *hit                 hit routine */
    NULL,			/* *ctrl                control routine */
    0, 0,			/* nxsc, nysc           max x,y sections */
    0, 0, 0,			/* skey, 2 spare        selection keystroke */
    NULL,			/* *pwcb            part window ctrl block */
    0, 0, 0, 0, 0, 0, NULL, NULL,	/* 6 short 2 pointer zero */
    CL_WRROW, CL_WBARB, CL_WBARS,	/* psac, psbc, pssc arrow/bar clrs */
    NULL,			/* *pwcb            part window ctrl block */
    0, 0, 0, 0, 0, 0, NULL, NULL,	/* 6 short 2 pointer zero */
    CL_WRROW, CL_WBARB, CL_WBARS,	/* psac, psbc, pssc arrow/bar clrs */
    NULL
};


static struct WM_appl appl[nappl + 1] =
{
    &aw0, NULL
};

static struct WM_wwork ww =	/* window working definition */
{
    &ws,			/* *wstat;              pointer to status area */
    NULL,			/* *wscale              this was pointer to WDEF */
    0,				/* chid                 channel ID */
    NULL,			/* *pprec               pointer to pointer record */
    0,				/* psave                pointer position saved */
    0, 0, 0, 0,			/* 4 zero */
    appl,			/* *splst               pointer to sprite list */
    438, 150,			/* xsize, ysize         size */
    0, 0,			/* xorg, yorg           and origin */
    NO_WCLEAR | 2,		/* flag                 no clear + shadow */
    1, 4, 84,			/* borw, borc, papr     border width/clr, paper */
    NULL,			/* *sprite              pointer to sprite */
    1, 1,			/* curw, curc           current item width/clr */
    3, 7, NULL, NULL,		/* uback, uink, *ublob, *upatt  unavail */
    7, 1, NULL, NULL,		/* aback, aink, *ablob, *apatt  avail */
    4, 0, NULL, NULL,		/* sback, sink, *sblob, *spatt  selected */
    NULL,			/* *help */
    ninfw, ninfo, infw,		/* ninfo, ninob, *pinfo info winds */
    nlitm, litm,		/* nlitm, *plitm        loose items */
    nappl, appl			/* nappl  *pappl        appl winds */
};

static int achid = 0;
static int iwait, ihit;

extern PXPRTHG pXB;
extern struct WM_wwork *Main_ww;

Prototype int InitXWindow (void *, int, int, int, int);
extern int QPTR_VERS;
extern char mono;
extern short inxpr;
extern void PollServer(void);
extern short iconic;

extern int SaveContext (int, void **, short *);
extern int RestoreContext (int, void *, short *, short);

typedef struct
{
    char flag;
    char fill[3];
    char *stats;
} KLUDGE;

static void logger(void)
{
    int pipeid;
    char c;
    
    if((pipeid = io_open("pipe_0", pXB->logid)) > 0)
    {
	int pstat;
	
        AddCapBuff (&Xfr, '\n');
	while(1)
	{
	    pstat = io_fbyte(pipeid, 10, &c);
	    if(pstat == 0)
	    {
		AddCapBuff (&Xfr, c);
	    }
	    else if(pstat < -1)
	    {
		break;
	    }
	    else if(Iserve)
	    {
		PollServer();
	    }
	}            
    }
}
int InitXWindow (void *ptr, int IPipe, int OPipe, int dirn, int flag)
{
    int n;
    short msgno;
    short zzz = 0;
    int nch;
    short kip = 0;
    int rdId = -1;
    KLUDGE klg;
    int ns = -1;
    void *px;
    short cdef[4];
    short nwake =0;

    iwait = ihit = 0;
    if(!iconic)
    {
	ns = SaveContext(pChId, &px, cdef);
	ws.wwork = &ww;
	achid = io_open ("scr", 0);
	{
	    int k;
	    
	    for(k = 0; k < 18; k++)
	    {
		xinfo[k].attr.t.ink = (mono) ? 7 : 4;
	    }
	    infw[0].papr = infw[2].papr = (mono) ? 127 : 84;
	    ww.borc = (mono) ? 7 : 4;
	}
    
	ws.litem[0] = ws.litem[1] = ws.litem[2] = WSI_AVBL;

	pXB->chid = achid;
	pXB->job = QTpid;
	pXB->flag = 0;
    }
    else
    {
	pXB->flag = 1;
	pXB->chid = -1;
    }
    klg.flag =  2 + mono; /* 2 for stats, 1 for mono */    
    klg.stats = SrvStats("Starting XPR");
    pXB->check = 0;
    pXB->buf = ptr;
    pXB->icon = 0;
    pXB->area = &klg;
    pXB->status = flag;

    msgno = dirn;

    if(!iconic && xicon == 0)
    {
        wm_pulld (&ww, 60, 40);
        wm_wdraw (&ww);
        pXB->icon = 1;
    }
    else
    {
        zzz = 1;
    }
    if((pXB->logid = io_open("pipe_128", 0)) > 0)
    {
        rdId = jcall(logger, "XPR logger", 1, 2048, 0);
    }

    n = io_sstrg (OPipe, -1, (char *) &msgno, 2);
    if(n > 0)
    {
	inxpr = 1;

        while (!iconic)
        {
            char *ictxt;
	    if (ws.evnt & PT_ZZZZ || zzz)
	    {

		/* Might make this configurable ?   */

	        pXB->flag = (xicon) ? xicon : 1;
                if(zzz)
                {
                    zzz = 0;
                }
                else
                {
                    wm_unset (&ww);
                }
                pXB->icon = 0;
                if(pXB->flag == 1)
                {
                    ictxt = "QTPI-XPR";
                }
                else
                {          /*01234567890123456789012345678*/ 
                    ictxt = "QTPI/XPR:0       /0  /0    %";
		    if(dirn == XMSG_RECV && 
		       (*MyProtocol == 'A'  
			|| *MyProtocol == 'K'
			|| *MyProtocol == 'X'))
		    {
			*(ictxt+24) = '\0';
		    }
		    else
		    {
			*(ictxt+24) = ' ';
		    }
                }
	        menu_button (Main_ww, ictxt, pXB);
		if(ns == 0 && px)
		{
		    RestoreContext(pChId, px, cdef, 1);
		}
                kip = 1;
		ww.xorg = ww.yorg = 0;
		wm_pulld (&ww, 60, 40);
		wm_wdraw (&ww);
		pXB->flag = 2;
	        DoStatus(); 
	    }
	    wm_rptr (&ww);
	    if (ws.evnt & PT_CAN)
	    {
		break;
	    }
        }
        n = io_fstrg (IPipe, -1, (char *) &msgno, 2);
    }
    if(rdId > 0)
    {
        mt_frjob(rdId, -1);
    }
    if(!iconic)
    {
	wm_cluns (&ww);
	ww.xorg = ww.yorg = 0;
	io_close (achid);
    }
    
    SrvStats("Completing XPR");    
    if (pXB->logid > 0)
    {
        io_close(pXB->logid);
    }

    if(!iconic && kip)
    {
	RestoreContext(pChId, px, cdef, 0);
    }
    else if (ns == 0 && px)
    {
	mt_rechp(px);
    }
    SrvStats("Idle");    
    inxpr = 0;

    return XPRTidy (pXB->status, n);
}

static AEXIT (struct WM_wwork *wwk, struct WM_litm *li)
{
    pXB->check = (li->item == 1) ? 1 : -1;
    ihit++;
    lit_reset (wwk, li->item);
    if (iwait > 1 || ihit > 5)
    {
	return PT__CAN;
    }
    else
    {
	return 0;
    }
}
static long ADRAW (struct WM_wwork *wwk, struct WM_appw *apw)
{
    wm_swdef (wwk, apw, achid);
    sd_setpa (achid, -1, 0);
    sd_setst (achid, -1, 0);
    sd_setin (achid, -1, 7);
    return 0;
}

static long AHIT (struct WM_wwork *wwk, struct WM_appw *apw,
		  struct WM_wstat *wst, short x, short y)
{
    if (iwait)
    {
	if (iwait == 2)
	{
	    wwk->wstat->evnt |= PT_CAN;
	}
	iwait++;
    }

    if (pXB->check == 0x10000)
    {
        if((pXB->flag & 1) == 1)
        {
            pXB->flag = 2;
        }
	pXB->check = 0;
	iwait = 1;
	if (bBeep)
	{
	    SOUND_OFF_MORE;
	}
    }
    if (iwait)
    {
	long rv;

	if(zquiet < 1)
	    rv = 1;
	else
	    rv = zquiet;
    }
    else
    {
	return AHIT_NORMAL;
    }
}



